// CREDIT: by VIDVOX (Ported from https://www.shadertoy.com/view/lssGDj)
// ISADORA_PLUGIN_DESC("ASCII Art")
// ISADORA_FLOAT_PARAM(size, ~5ox, 0, 1, 0.1, "No help available.")
// ISADORA_FLOAT_PARAM(gamma, ]Z6S, 0.5, 2, 1, "No help available.")
// ISADORA_FLOAT_PARAM(tint, s-XL, 0, 1, 1, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(tintColor, _0tS, 0xFF00FF00, "No help available.")
// ISADORA_INT_PARAM_ONOFF(alphaMode, mUZ{, 0, "No help available.")


uniform sampler2D tex0;
uniform float size;
uniform float gamma;
uniform float tint;
uniform vec4 tintColor;
uniform bool alphaMode;
uniform vec2 resolution;



float character(float n, vec2 p) // some compilers have the word "char" reserved
{
	p = floor(p*vec2(4.0, -4.0) + 2.5);
	if (clamp(p.x, 0.0, 4.0) == p.x && clamp(p.y, 0.0, 4.0) == p.y)
	{
		if (int(mod(n/exp2(p.x + 5.0*p.y), 2.0)) == 1) return 1.0;
	}	
	return 0.0;
}



void main()	{
	float _size = size*36.0+8.0;
	vec2 uv = gl_FragCoord.xy;
	vec4 inputColor = texture2D(tex0, (floor(uv/_size)*_size/resolution.xy));
	vec3 col = inputColor.rgb;
	float gray = (col.r + col.g + col.b)/3.0;
	gray = pow(gray, gamma);
	col = mix(tintColor.rgb, col.rgb, 1.0-tint);
	
	float n =  65536.0;             // .
	if (gray > 0.2) n = 65600.0;    // :
	if (gray > 0.3) n = 332772.0;   // *
	if (gray > 0.4) n = 15255086.0; // o 
	if (gray > 0.5) n = 23385164.0; // &
	if (gray > 0.6) n = 15252014.0; // 8
	if (gray > 0.7) n = 13199452.0; // @
	if (gray > 0.8) n = 11512810.0; // #
		
	vec2 p = mod(uv/(_size/2.0), 2.0) - vec2(1.0);
	col = col*character(n, p);
	float alpha = mix(tintColor.a * inputColor.a, inputColor.a, 1.0-tint);
	if (alphaMode)	{
		alpha = (col.r + col.g + col.b)/3.0;
		alpha = (alpha > 0.01) ? tintColor.a : alpha;
	}
	
	gl_FragColor = vec4(col,alpha);

}
