// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/Bounce.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(bounces, QS{u, 0, 10, 2, "No help available.")
// ISADORA_FLOAT_PARAM(shadow_height, l>9}, 0, 1, 0.1, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(shadow_colour, {Fb^, 0xFF000000, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float bounces;
uniform float shadow_height;
uniform vec4 shadow_colour;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: Adrian Purser
// License: MIT


const float PI = 3.14159265358;

vec4 transition (vec2 uv) {
  float time = progress;
  float stime = sin(time * PI / 2.);
  float phase = time * PI * bounces;
  float y = (abs(cos(phase))) * (1.0 - stime);
  float d = uv.y - y;
  return mix(
    mix(
      getToColor(uv),
      shadow_colour,
      step(d, shadow_height) * (1. - mix(
        ((d / shadow_height) * shadow_colour.a) + (1.0 - shadow_colour.a),
        1.0,
        smoothstep(0.95, 1., progress) // fade-out the shadow at the end
      ))
    ),
    getFromColor(vec2(uv.x, uv.y + (1.0 - y))),
    step(d, 0.0)
  );
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
