// CREDIT: by toneburst
// ISADORA_FLOAT_PARAM(master_zoom, ~iT~, 0.1, 2, 1, "No help available.")
// ISADORA_FLOAT_PARAM(red_zoom, &Wpp, 1, 1.5, 1, "No help available.")
// ISADORA_FLOAT_PARAM(green_zoom, #O%m, 1, 1.5, 1, "No help available.")
// ISADORA_FLOAT_PARAM(blue_zoom, R|T9, 1, 1.5, 1, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0.5, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform float master_zoom;
uniform float red_zoom;
uniform float green_zoom;
uniform float blue_zoom;
uniform float center_x;
uniform float center_y;

void main() {
	vec2		loc;
	vec2		modifiedCenter;
	
	loc = gl_TexCoord[0].xy;
	modifiedCenter = center;
	
	vec2 locR = (loc - modifiedCenter)*(1.0/(red_zoom*master_zoom)) + modifiedCenter;
	vec2 locG = (loc - modifiedCenter)*(1.0/(green_zoom*master_zoom)) + modifiedCenter;
	vec2 locB = (loc - modifiedCenter)*(1.0/(blue_zoom*master_zoom)) + modifiedCenter;
	
	vec4 outPix;
	outPix.r = texture2D(tex0, locR).r;
	outPix.g = texture2D(tex0, locG).g;
	outPix.b = texture2D(tex0, locB).b;

	loc.x = (loc.x - modifiedCenter.x)*(1.0/master_zoom) + modifiedCenter.x;
	loc.y = (loc.y - modifiedCenter.y)*(1.0/master_zoom) + modifiedCenter.y;
	
	outPix.a = texture2D(tex0, loc).a;
	gl_FragColor = outPix;
}
