// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(radius, oHO5, 0, 0.75, 0.125, "No help available.")
// ISADORA_FLOAT_PARAM(streaks, dqaL, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0.5, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform float radius;
uniform float streaks;
uniform float center_x;
uniform float center_y;
uniform vec2 resolution;




//	Pretty simple ‚Äì¬ if we're inside the radius, draw as normal
//	If we're outside the circle grab the last color along the angle

#ifndef GL_ES
float distance (vec2 inCenter, vec2 pt)
{
	float tmp = pow(inCenter.x-pt.x,2.0)+pow(inCenter.y-pt.y,2.0);
	return pow(tmp,0.5);
}
#endif

void main() {
	vec2 uv = vec2(gl_TexCoord[0].xy[0],gl_TexCoord[0].xy[1]);
	vec2 texSize = resolution;
	vec2 tc = uv * texSize;
	vec2 tc2 = uv * texSize;
	vec2 modifiedCenter = center * texSize;
	float r = distance(modifiedCenter, tc);
	float render_length = length(resolution);
	float a = atan ((tc.y-modifiedCenter.y),(tc.x-modifiedCenter.x));
	float radius_sized = clamp(radius * render_length, 1.0, render_length);
	
	tc -= modifiedCenter;
	tc2 -= modifiedCenter;

	if (r < radius_sized) 	{
		tc.x = r * cos(a);
		tc.y = r * sin(a);
		tc2 = tc;
	}
	else	{
		tc.x = radius_sized * cos(a);
		tc.y = radius_sized * sin(a);
		tc2.x = (radius_sized + streaks * render_length) * cos(a);
		tc2.y = (radius_sized + streaks * render_length) * sin(a); 
	}
	tc += modifiedCenter;
	tc2 += modifiedCenter;
	vec2 loc = tc / texSize;

	if ((loc.x < 0.0)||(loc.y < 0.0)||(loc.x > 1.0)||(loc.y > 1.0))	{
		gl_FragColor = vec4(0.0);
	}
	else	{
		vec4 result = texture2D(tex0, loc);
		if (streaks > 0.0)	{
			vec2 loc2 = tc2 / texSize;
			vec4 mixColor = texture2D(tex0, loc2);
			result = mix(result, mixColor, clamp(2.0*((r - radius_sized)/(render_length))*streaks,0.0,1.0));
		}
		gl_FragColor = result;
	}
}
