// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/circle.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(backColor, sc3A, 0xFF000000, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0.5, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform vec4 backColor;
uniform float center_x;
uniform float center_y;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: Fernando Kuteken
// License: MIT


vec4 transition (vec2 uv) {
  
  float distance = length(uv - center);
  float radius = sqrt(8.0) * abs(progress - 0.5);
  
  if (distance > radius) {
    return backColor;
  }
  else {
    if (progress < 0.5) return getFromColor(uv);
    else return getToColor(uv);
  }
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
