// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(minLevel, pTsy, 0, 1, 0.2, "No help available.")
// ISADORA_FLOAT_PARAM(midLevel, ulzB, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(maxLevel, [o$8, 0, 1, 0.8, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(offset1, >7Q^, 0x7F7F7F7F, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(offset2, zoMW, 0x7F7F7F7F, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(offset3, %Gy/, 0x7F7F7F7F, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(offset4, ^A=w, 0x7F7F7F7F, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(offset5, +Ih6, 0x7F7F7F7F, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(offset6, f<$b, 0x7F7F7F7F, "No help available.")
// ISADORA_INT_PARAM_ONOFF(levelsMode, kD^D, 0, "No help available.")


uniform sampler2D tex0;
uniform float minLevel;
uniform float midLevel;
uniform float maxLevel;
uniform vec4 offset1;
uniform vec4 offset2;
uniform vec4 offset3;
uniform vec4 offset4;
uniform vec4 offset5;
uniform vec4 offset6;
uniform bool levelsMode;



void main() {
	vec4		tmpColor = texture2D(tex0, gl_TexCoord[0].xy);
	float brightness = (tmpColor.r + tmpColor.g + tmpColor.b) * tmpColor.a / 3.0;
	
	//	all adjustments
	if (brightness <= minLevel)	{
		tmpColor = tmpColor + offset1 - 0.5;
	}
	else if (brightness <= (minLevel + midLevel)/2.0)	{
		tmpColor = tmpColor + offset2 - 0.5;
	}
	else if (brightness <= midLevel)	{
		tmpColor = tmpColor + offset3 - 0.5;
	}
	else if (brightness <= (maxLevel + midLevel)/2.0)	{
		tmpColor = tmpColor + offset4 - 0.5;
	}
	else if (brightness <= maxLevel)	{
		tmpColor = tmpColor + offset5 - 0.5;
	}
	else	{
		tmpColor = tmpColor + offset6 - 0.5;
	}	
	
	if (levelsMode)	{
		//	all adjustments
		tmpColor.rgb = vec3(1.0);
		
		if (brightness <= minLevel)	{
			tmpColor.a = 0.0;
		}
		else if (brightness <= (minLevel + midLevel)/2.0)	{
			tmpColor.a = 1.0/5.0;
		}
		else if (brightness <= midLevel)	{
			tmpColor.a = 2.0/5.0;
		}
		else if (brightness <= (maxLevel + midLevel)/2.0)	{
			tmpColor.a = 3.0/5.0;
		}
		else if (brightness <= maxLevel)	{
			tmpColor.a = 4.0/5.0;
		}
		else	{
			tmpColor.a = 1.0;
		}
	}
	gl_FragColor = clamp(tmpColor, 0.0, 1.0);
}

