// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/colorphase.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(fromStep, I-lW, 0x00003264, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(toStep, 1rJ+, 0xFF99CCFF, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform vec4 fromStep;
uniform vec4 toStep;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: gre
// License: MIT

// Usage: fromStep and toStep must be in [0.0, 1.0] range 
// and all(fromStep) must be < all(toStep)


vec4 transition (vec2 uv) {
  vec4 a = getFromColor(uv);
  vec4 b = getToColor(uv);
  return mix(a, b, smoothstep(fromStep, toStep, vec4(progress)));
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
