// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(horizontal_magnitude, J-1Q, 0, 1, 0.125, "No help available.")
// ISADORA_FLOAT_PARAM(vertical_magnitude, 8N6N, 0, 1, 0.125, "No help available.")
// ISADORA_FLOAT_PARAM(color_magnitude, Ug^s, 0, 2, 1, "No help available.")
// ISADORA_INT_PARAM(mode, aZHp, 0, 3, 0, "No help available.")


uniform sampler2D tex0;
uniform float horizontal_magnitude;
uniform float vertical_magnitude;
uniform float color_magnitude;
uniform int mode;
uniform float time;



//	adapted from maxilla inc's https://github.com/maxillacult/ofxPostGlitch/



float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}



void main()
{
	
	vec2 texCoord = gl_TexCoord[0].xy;

	vec4 col = texture2D(tex0, texCoord);

	vec4 col_r = vec4(0.0);
	vec4 col_l = vec4(0.0);
	vec4 col_g = vec4(0.0);

	vec2 rand_offset = texCoord + vec2((horizontal_magnitude * rand(vec2(time,0.213))-horizontal_magnitude/2.0), (vertical_magnitude * rand(vec2(time,0.463467))) - vertical_magnitude / 2.0);
	col_r = texture2D(tex0, rand_offset);
	rand_offset = texCoord + vec2((horizontal_magnitude * rand(vec2(time,0.5345))-horizontal_magnitude/2.0), (vertical_magnitude * rand(vec2(time,0.7875))) - vertical_magnitude / 2.0);
	col_l = texture2D(tex0, rand_offset);
	rand_offset = texCoord + vec2((horizontal_magnitude * rand(vec2(time,0.456345))-horizontal_magnitude/2.0), (vertical_magnitude * rand(vec2(time,0.9432))) - vertical_magnitude / 2.0);
	col_g = texture2D(tex0, rand_offset);

	vec4 color_shift;
	color_shift.b = color_magnitude*col_r.b*max(1.0,sin(texCoord.y*1.2)*2.5)*rand(vec2(time,0.0342));
	color_shift.r = color_magnitude*col_l.r*max(1.0,sin(texCoord.y*1.2)*2.5)*rand(vec2(time,0.5253));
	color_shift.g = color_magnitude*col_g.g*max(1.0,sin(texCoord.y*1.2)*2.5)*rand(vec2(time,0.1943));

	//	if doing add maths
	if (mode == 0)	{
		col = col + color_shift;
	}
	//	add mod
	else if (mode == 1)	{
		col = mod(col + color_shift,1.001);
	}
	//	multiply
	else if (mode == 2)	{
		col = mix(col, col * (color_magnitude + color_shift),0.9);
	}
	// difference
	else if (mode == 3)	{
		col = abs(color_shift - col);
	}

	gl_FragColor = col;
}
