// CREDIT: VIDVOX
// ISADORA_PLUGIN_DESC("Generates a gradient that fades between four different colors.")
// ISADORA_VEC4_COLOR_PARAM(color1, Yc>j, 0xFFFF0000, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color2, CrWY, 0xFF00FF00, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color3, yK2k, 0xFF0000FF, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color4, 6XNp, 0xFFFFFFFF, "No help available.")
// ISADORA_FLOAT_PARAM(rotationAngle, Cz=k, 0, 1, 0, "No help available.")


uniform vec4 color1;
uniform vec4 color2;
uniform vec4 color3;
uniform vec4 color4;
uniform float rotationAngle;
uniform vec2 resolution;

const float pi = 3.1415926535897932384626433832795;

vec2 rotatePointNorm(vec2 pt, float rot)	{
	vec2 returnMe = pt;

	float r = distance(vec2(0.50), returnMe);
	float a = atan((returnMe.y-0.5),(returnMe.x-0.5));

	returnMe.x = r * cos(a + 2.0 * pi * rot - pi) + 0.5;
	returnMe.y = r * sin(a + 2.0 * pi * rot - pi) + 0.5;
	
	returnMe = returnMe;
	
	return returnMe;
}

void main()	{
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	vec4		inputPixelColor = vec4(0.0);
	vec4		dist = vec4(0.0);
	vec2		pt = isf_FragNormCoord;
	pt = rotatePointNorm(pt,rotationAngle+0.5);
	dist.r = max(1.0-distance(vec2(0.0,0.0),pt),0.0);
	dist.g = max(1.0-distance(vec2(1.0,0.0),pt),0.0);
	dist.b = max(1.0-distance(vec2(0.0,1.0),pt),0.0);
	dist.a = max(1.0-distance(vec2(1.0,1.0),pt),0.0);
	
	inputPixelColor = (color1 * dist.r + color2 * dist.g + color3 * dist.b + color4 * dist.a) / (dist.r + dist.g + dist.b + dist.a);
	
	gl_FragColor = inputPixelColor;
}
