// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/CrazyParametricFun.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(b, x979, 0, 10, 1, "No help available.")
// ISADORA_FLOAT_PARAM(smoothness, s>84, -1000000, +1000000, 0, "No help available.")
// ISADORA_FLOAT_PARAM(amplitude, ?6Ev, 0, 360, 120, "No help available.")
// ISADORA_FLOAT_PARAM(a, Pp\[, 0, 10, 4, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float b;
uniform float smoothness;
uniform float amplitude;
uniform float a;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: mandubian
// License: MIT


vec4 transition(vec2 uv) {
  vec2 p = uv.xy / vec2(1.0).xy;
  vec2 dir = p - vec2(.5);
  float dist = length(dir);
  float x = (a - b) * cos(progress) + b * cos(progress * ((a / b) - 1.) );
  float y = (a - b) * sin(progress) - b * sin(progress * ((a / b) - 1.));
  vec2 offset = dir * vec2(sin(progress  * dist * amplitude * x), sin(progress * dist * amplitude * y)) / smoothness;
  return mix(getFromColor(p + offset), getToColor(p), smoothstep(0.2, 1.0, progress));
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
