// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/crosshatch.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(fadeEdge, q>0/, -1000000, +1000000, 0, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(threshold, b2lq, 0, 10, 3, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float fadeEdge;
uniform float center_x;
uniform float center_y;
uniform float threshold;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// License: MIT
// Author: pthrasher
// adapted by gre from https://gist.github.com/pthrasher/04fd9a7de4012cbb03f6


float rand(vec2 co) {
  return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}
vec4 transition(vec2 p) {
  float dist = distance(center, p) / threshold;
  float r = progress - min(rand(vec2(p.y, 0.0)), rand(vec2(0.0, p.x)));
  return mix(getFromColor(p), getToColor(p), mix(0.0, mix(step(dist, r), 1.0, smoothstep(1.0-fadeEdge, 1.0, progress)), smoothstep(0.0, fadeEdge, progress)));    
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
