// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/directionalwarp.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(direction_x, /ySg, -1, 1, -1, "No help available.")
// ISADORA_FLOAT_PARAM(direction_y, 1>51, -1, 1, 1, "No help available.")

#define direction vec2(direction_x,direction_y)

uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float direction_x;
uniform float direction_y;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: pschroen
// License: MIT


const float smoothness = 0.5;
const vec2 center = vec2(0.5, 0.5);

vec4 transition (vec2 uv) {
  vec2 v = normalize(direction);
  v /= abs(v.x) + abs(v.y);
  float d = v.x * center.x + v.y * center.y;
  float m = 1.0 - smoothstep(-smoothness, 0.0, v.x * uv.x + v.y * uv.y - (d - 0.5 + progress * (1.0 + smoothness)));
  return mix(getFromColor((uv - 0.5) * (1.0 - m) + 0.5), getToColor((uv - 0.5) * m + 0.5), m);
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
