// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/directionalwipe.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(direction_x, /ySg, -1, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(direction_y, 1>51, -1, 1, -1, "No help available.")
// ISADORA_FLOAT_PARAM(smoothness, s>84, 0, 1, 0.5, "No help available.")

#define direction vec2(direction_x,direction_y)

uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float direction_x;
uniform float direction_y;
uniform float smoothness;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: gre
// License: MIT

 
const vec2 center = vec2(0.5, 0.5);
 
vec4 transition (vec2 uv) {
  vec2 v = normalize(direction);
  v /= abs(v.x)+abs(v.y);
  float d = v.x * center.x + v.y * center.y;
  float m =
    (1.0-step(progress, 0.0)) * // there is something wrong with our formula that makes m not equals 0.0 with progress is 0.0
    (1.0 - smoothstep(-smoothness, 0.0, v.x * uv.x + v.y * uv.y - (d-0.5+progress*(1.+smoothness))));
  return mix(getFromColor(uv), getToColor(uv), m);
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
