// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/Directional.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(direction_x, /ySg, -1, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(direction_y, 1>51, -1, 1, 1, "No help available.")

#define direction vec2(direction_x,direction_y)

uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float direction_x;
uniform float direction_y;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: Gaëtan Renaudeau
// License: MIT


vec4 transition (vec2 uv) {
  vec2 p = uv + progress * sign(direction);
  vec2 f = fract(p);
  return mix(
    getToColor(f),
    getFromColor(f),
    step(0.0, p.y) * step(p.y, 1.0) * step(0.0, p.x) * step(p.x, 1.0)
  );
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
