// CREDIT: by @colin_movecraft
// ISADORA_PLUGIN_DESC("Simple Displace")
// ISADORA_FLOAT_PARAM(uDisplaceAmt, sfUi, -2, 2, 0, "No help available.")
// ISADORA_INT_PARAM(xComponent, QvMp, 0, 4, 1, "No help available.")
// ISADORA_INT_PARAM(yComponent, UYuK, 0, 4, 2, "No help available.")
// ISADORA_INT_PARAM_ONOFF(relativeShift, >BoP, 0, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float uDisplaceAmt;
uniform int xComponent;
uniform int yComponent;
uniform bool relativeShift;



void main(){
	vec2	p = gl_TexCoord[0].xy;
	vec4	displacePixel = texture2D(tex1, p);
    
    float	r = (displacePixel.r);
    float	g = (displacePixel.g);
    float	b = (displacePixel.b);
    float	a = (displacePixel.a);
    float	avg = (r+g+b)/3.0;
    
    vec2	displace = vec2(avg,avg);
    if (xComponent==1)
    	displace.x = r;
	else if (xComponent==2)
    	displace.x = g;
    else if (xComponent==3)
    	displace.x = b;
	else if (xComponent==4)
    	displace.x = a;

    if (yComponent==1)
    	displace.y = r;
	else if (yComponent==2)
    	displace.y = g;
    else if (yComponent==3)
    	displace.y = b;
	else if (yComponent==4)
    	displace.y = a;
    
    displace = (relativeShift) ? 2.0 * (displace - vec2(0.5)) : displace;
    displace *= uDisplaceAmt;
    
	gl_FragColor = texture2D(tex0, p+displace);
}
