// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(hShift, 3H0u, -0.05, 0.05, 0, "No help available.")
// ISADORA_FLOAT_PARAM(vShift, u|Va, -0.05, 0.05, 0, "No help available.")
// ISADORA_FLOAT_PARAM(mixAmount1, be39, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(mixAmount2, ]Fdo, 0, 1, 0.5, "No help available.")


uniform sampler2D tex0;
uniform float hShift;
uniform float vShift;
uniform float mixAmount1;
uniform float mixAmount2;



void main()
{
	vec2 loc = gl_TexCoord[0].xy;
	vec2 shift = vec2(hShift, vShift);

	//	zoom slightly so that there aren't out of range pixels
	float zoomAmount = 1.0 + 2.0 * max(hShift, vShift);
	vec2 modifiedCenter = vec2(0.5,0.5);
	loc.x = (loc.x - modifiedCenter.x)*(1.0/zoomAmount) + modifiedCenter.x;
	loc.y = (loc.y - modifiedCenter.y)*(1.0/zoomAmount) + modifiedCenter.y;
	
	vec4 color = texture2D(tex0, gl_TexCoord[0].xy);
	vec4 colorL = texture2D(tex0, clamp(loc - shift,0.0,1.0));
	vec4 colorR = texture2D(tex0, clamp(loc + shift,0.0,1.0));
	
	vec4 outColor = mix(min(colorL, colorR), max(colorL, colorR), mixAmount1);
	outColor =  mix(min(outColor, color), max(outColor, color), mixAmount2);
	
	gl_FragColor = outColor;
}
