// CREDIT: Inspired by Side Scroller and Flip by BrianChasalow
// ISADORA_FLOAT_PARAM(slidetop, DL%~, 0, 2, 0, "No help available.")
// ISADORA_FLOAT_PARAM(shifttop, niwF, 0, 2, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(mirrorHorizontaltop, <]gO, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(mirrorVerticaltop, l5TB, 0, "No help available.")
// ISADORA_FLOAT_PARAM(slidebot, 5N[G, 0, 2, 0, "No help available.")
// ISADORA_FLOAT_PARAM(shiftbot, $TNE, 0, 2, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(mirrorHorizontalbot, xb9%, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(mirrorVerticalbot, Bu$}, 0, "No help available.")


uniform sampler2D tex0;
uniform float slidetop;
uniform float shifttop;
uniform bool mirrorHorizontaltop;
uniform bool mirrorVerticaltop;
uniform float slidebot;
uniform float shiftbot;
uniform bool mirrorHorizontalbot;
uniform bool mirrorVerticalbot;

void main(void)
{
	vec2 pt = gl_TexCoord[0].xy;
	float slide = (gl_TexCoord[0].xy.y > 0.5) ? slidetop : slidebot;
	float shift = (gl_TexCoord[0].xy.x < 0.5) ? shifttop : shiftbot;

	bool mirrorHorizontal = (gl_TexCoord[0].xy.y > 0.5) ? mirrorHorizontaltop : mirrorHorizontalbot;
	bool mirrorVertical = (gl_TexCoord[0].xy.x < 0.5) ? mirrorVerticaltop : mirrorVerticalbot;
	pt.x += slide;
	pt.y += shift;
	vec2 moddedRetard = mod(pt,1.0);
	
	if(mirrorHorizontal && pt.x >= 1.0 && pt.x <= 2.0)
		moddedRetard = vec2(1.0-moddedRetard.x, moddedRetard.y);
	if(mirrorVertical && pt.y >= 1.0 && pt.y <= 2.0)
		moddedRetard = vec2(moddedRetard.x, 1.0-moddedRetard.y);
	
	vec4 pixel = texture2D(tex0, moddedRetard);
	gl_FragColor = pixel;
}
