// CREDIT: by VIDVOX
// ISADORA_PLUGIN_DESC("Visualizes an FFT analysis image with custom set colors for frequency domain")
// ISADORA_FLOAT_PARAM(gainFFT, B+s/, 0, 5, 1, "No help available.")
// ISADORA_FLOAT_PARAM(rangeFFT, l]t9, 0, 1, 0.9, "No help available.")
// ISADORA_FLOAT_PARAM(waveSize, Yr5%, 0, 0.5, 0.05, "No help available.")
// ISADORA_INT_PARAM_ONOFF(vertical, |1G=, 1, "No help available.")
// ISADORA_INT_PARAM_ONOFF(stereo, QcGW, 1, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color1, Yc>j, 0xFF35FB2F, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color2, CrWY, 0xFF007FFF, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color3, yK2k, 0xFF00FF00, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(wavecolor, R-Hg, 0xFFFFFFFF, "No help available.")


uniform float gainFFT;
uniform float rangeFFT;
uniform float waveSize;
uniform bool vertical;
uniform bool stereo;
uniform vec4 color1;
uniform vec4 color2;
uniform vec4 color3;
uniform vec4 wavecolor;
uniform vec2 resolution;



void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	
	vec2		loc = isf_FragNormCoord;

	if (vertical)	{
		loc.x = isf_FragNormCoord[1];
		loc.y = isf_FragNormCoord[0];
	}
	
	vec4 mixColor = color1;
	
	if (loc.y > 0.5)	{
		mixColor = mix (color2,color3,(loc.y-0.5)*2.0);
	}
	else	{
		mixColor = mix (color1,color2,(loc.y*2.0));
	}
	
	loc.y = loc.y * rangeFFT;
	
	vec2		fftSize = IMG_SIZE(fftImage);
	vec2		rawSize = IMG_SIZE(waveImage);
	float		channel = 0.5;
	float		offset = 0.0;
	if (stereo == true)	{
		channel = (loc.x > 0.5) ? 0.0 : 1.0;
		offset = (loc.x > 0.5) ? 0.25 : -0.25;
	}
	
	vec4 		fft = IMG_NORM_PIXEL(fftImage, vec2(loc.y,channel));
	fft = mixColor * fft.r * 3.0;
	fft.rgb = gainFFT * fft.rgb;
	vec2		waveLoc = vec2(loc.y,channel);
	vec4		wave = IMG_NORM_PIXEL(waveImage, waveLoc)+offset;
	//wave = vec4(wave.r);
	vec4		waveAdd = ((1.0 - smoothstep(0.0, waveSize, abs(wave - loc.x))) * wavecolor) * wavecolor.a;
	fft += waveAdd;
	fft.a = mixColor.a + clamp((waveAdd.r + waveAdd.g + waveAdd.b) * wavecolor.a,0.0,1.0);
	
	gl_FragColor = fft;
}
