// CREDIT: by VIDVOX
// ISADORA_PLUGIN_DESC("Visualizes an FFT analysis image with custom set colors for frequency domain")
// ISADORA_FLOAT_PARAM(strokeSize, wZ<&, 0, 0.25, 0.1, "No help available.")
// ISADORA_FLOAT_PARAM(gain, laoL, 1, 5, 1, "No help available.")
// ISADORA_FLOAT_PARAM(minRange, sy>&, 0, 1, 0.1, "No help available.")
// ISADORA_FLOAT_PARAM(maxRange, mKCp, 0, 1, 0.9, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(topColor, ]/nh, 0x00000000, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(bottomColor, >Z6X, 0xFF007FE5, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(strokeColor, ts5d, 0xFF3F3F3F, "No help available.")


uniform float strokeSize;
uniform float gain;
uniform float minRange;
uniform float maxRange;
uniform vec4 topColor;
uniform vec4 bottomColor;
uniform vec4 strokeColor;
uniform vec2 resolution;



void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	
	vec2 loc = isf_FragNormCoord;
	
	//	the fftImage is 256 steps
	loc.x = loc.x * abs(maxRange - minRange) + minRange;
	
	vec4 fft = IMG_NORM_PIXEL(fftImage, vec2(loc.x,0.5));
	float fftVal = gain * (fft.r + fft.g + fft.b) / 3.0;
	if (loc.y > fftVal)
		fft = topColor;
	else
		fft = bottomColor;
	if ((strokeSize > 0.0) && (abs(fftVal - loc.y) < strokeSize))	{
		fft = mix(strokeColor, fft, abs(fftVal - loc.y) / strokeSize);
	}
	
	//(smoothstep(0.0, stroke, abs(fftVal - loc.y))) * strokeColor);
	gl_FragColor = fft;
}
