// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/flyeye.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(size, ~5ox, 0, 1, 0.04, "No help available.")
// ISADORA_FLOAT_PARAM(colorSeparation, hCtB, 0, 1, 0.3, "No help available.")
// ISADORA_FLOAT_PARAM(zoom, >y\9, 0, 100, 50, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float size;
uniform float colorSeparation;
uniform float zoom;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: gre
// License: MIT

vec4 transition(vec2 p) {
  float inv = 1. - progress;
  vec2 disp = size*vec2(cos(zoom*p.x), sin(zoom*p.y));
  vec4 texTo = getToColor(p + inv*disp);
  vec4 texFrom = vec4(
    getFromColor(p + progress*disp*(1.0 - colorSeparation)).r,
    getFromColor(p + progress*disp).g,
    getFromColor(p + progress*disp*(1.0 + colorSeparation)).b,
    1.0);
  return texTo*progress + texFrom*inv;
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
