// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(glitch_size, eI+>, 0, 0.5, 0.1, "No help available.")
// ISADORA_FLOAT_PARAM(glitch_horizontal, 3RTa, 0, 1, 0.2, "No help available.")
// ISADORA_FLOAT_PARAM(glitch_vertical, 97}8, 0, 1, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(randomize_size, Fgj+, 1, "No help available.")
// ISADORA_INT_PARAM_ONOFF(randomize_zoom, =~0j, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(use_alt_image, Ypm<, 0, "No help available.")
// ISADORA_FLOAT_PARAM(offset_x, r5~+, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(offset_y, x[{~, 0, 1, 0, "No help available.")

#define offset vec2(offset_x,offset_y)

uniform sampler2D tex0;
uniform float glitch_size;
uniform float glitch_horizontal;
uniform float glitch_vertical;
uniform bool randomize_size;
uniform bool randomize_zoom;
uniform bool use_alt_image;
uniform sampler2D tex1;
uniform float offset_x;
uniform float offset_y;
uniform float time;

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main()
{
	vec2 xy;
	vec4 returnMe;
	bool shifted = false;
	xy.x = gl_TexCoord[0].xy[0];
	xy.y = gl_TexCoord[0].xy[1];
	
	//	quantize the xy to the glitch_amount size
	//xy = floor(xy / glitch_size) * glitch_size;
	vec2 random;

	float local_glitch_size = glitch_size;
	float random_offset = 0.0;
	
	if (randomize_size)	{
		random_offset = mod(rand(vec2(time,time)), 1.0);
		local_glitch_size = random_offset * glitch_size;
	}
	
	if (local_glitch_size > 0.0)	{
		random.x = rand(vec2(floor(random_offset + xy.y / local_glitch_size) * local_glitch_size, time));
		random.y = rand(vec2(floor(random_offset + xy.x / local_glitch_size) * local_glitch_size, time));
	}
	else	{
		random.x = rand(vec2(xy.x, time));
		random.y = rand(vec2(xy.y, time));
	}
	
	if (randomize_zoom)	{
		if ((random.x < glitch_horizontal)&&(random.y < glitch_vertical))	{
			float level = rand(vec2(random.x, random.y)) / 5.0 + 0.90;
			xy = (xy - vec2(0.5))*(1.0/level) + vec2(0.5);
		}
		else if (random.x < glitch_horizontal)	{
			float level = (random.x) + 0.98;
			xy = (xy - vec2(0.5))*(1.0/level) + vec2(0.5);
		}
		else if (random.y < glitch_vertical)	{
			float level = (random.y) + 0.98;
			xy = (xy - vec2(0.5))*(1.0/level) + vec2(0.5);
		}
	}
	
	//	if doing a horizontal glitch do a random shift
	if ((random.x < glitch_horizontal)&&(random.y < glitch_vertical))	{
		vec2 shift = (offset - 0.5);
		shift = shift * rand(shift + random);
		xy.x = mod(xy.x + random.x, 1.0);
		xy.y = mod(xy.y + random.y, 1.0);
		xy = xy + shift;
		shifted = true;
	}
	else if (random.x < glitch_horizontal)	{
		vec2 shift = (offset - 0.5);
		shift = shift * rand(shift + random);
		xy = mod(xy + vec2(0.0, random.x) + shift, 1.0);
		shifted = true;
	}
	else if (random.y < glitch_vertical)	{
		vec2 shift = (offset - 0.5);
		shift = shift * rand(shift + random);
		xy = mod(xy + vec2(random.y, 0.0) + shift, 1.0);
		shifted = true;
	}
	
	if ((shifted) && (use_alt_image) && (rand(vec2(time, xy.x)) < 0.5))
		returnMe = texture2D(tex1, xy);
	else
		returnMe = texture2D(tex0, xy);
	
	gl_FragColor = returnMe;
}
