// CREDIT: by VIDVOX
// ISADORA_PLUGIN_DESC("adapted from https://github.com/neilmendoza/ofxPostProcessing/blob/master/src/GodRaysPass.cpp")
// ISADORA_FLOAT_PARAM(lightDirDOTviewDir, *E7H, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(lightPositionOnScreen_x, 0~+7, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(lightPositionOnScreen_y, #%Ci, 0, 1, 0.5, "No help available.")
// ISADORA_INT_PARAM(quality, 4yuj, 0, 2, 10, "No help available.")

#define lightPositionOnScreen vec2(lightPositionOnScreen_x,lightPositionOnScreen_y)

uniform sampler2D tex0;
uniform float lightDirDOTviewDir;
uniform float lightPositionOnScreen_x;
uniform float lightPositionOnScreen_y;
uniform int quality;


void main(void)
{
	vec4 origColor = texture2D(tex0, gl_TexCoord[0].xy);
	vec4 raysColor = texture2D(tex0, gl_TexCoord[0].xy);
	int NUM_SAMPLES = quality;

	if (lightDirDOTviewDir>0.0){
		float exposure	= 0.1/float(NUM_SAMPLES);
		float decay		= 1.0 ;
		float density	= 0.5;
		float weight	= 6.0;
		float illuminationDecay = 1.0;
		vec2		normSrcCoord;

		normSrcCoord.x = gl_TexCoord[0].xy[0];
		normSrcCoord.y = gl_TexCoord[0].xy[1];

		vec2 deltaTextCoord = vec2(normSrcCoord.st - lightPositionOnScreen);
		vec2 textCoo = normSrcCoord;
		deltaTextCoord *= 1.0 / float(NUM_SAMPLES) * density;

		for(int i=0; i < NUM_SAMPLES ; i++)	{
			textCoo -= deltaTextCoord;
			vec4 tsample = texture2D(tex0, textCoo);
			tsample *= illuminationDecay * weight;
			raysColor += tsample;
			illuminationDecay *= decay;
		}
		raysColor *= exposure * lightDirDOTviewDir;
		float p = 0.3 *raysColor.g + 0.59*raysColor.r + 0.11*raysColor.b;
		gl_FragColor = origColor + p;
	}
	else {
		gl_FragColor = origColor;
	}
}
