// CREDIT: VIDVOX
// ISADORA_PLUGIN_DESC("Draws basic graph paper pattern")
// ISADORA_VEC4_COLOR_PARAM(bgColor, 8NtS, 0xFFEFEFF7, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(lineColor, $98w, 0xFFA3C4F4, "No help available.")
// ISADORA_INT_PARAM(majorDivisions, 2IS<, 0, 16, 3, "No help available.")
// ISADORA_INT_PARAM(minorHDivisions, pD1<, 0, 8, 2, "No help available.")
// ISADORA_INT_PARAM(minorVDivisions, MFp|, 0, 8, 2, "No help available.")
// ISADORA_FLOAT_PARAM(majorDivisionLineWidth, g^PV, 1, 5, 3, "No help available.")
// ISADORA_INT_PARAM_ONOFF(square, Z<KL, 0, "No help available.")


uniform vec4 bgColor;
uniform vec4 lineColor;
uniform int majorDivisions;
uniform int minorHDivisions;
uniform int minorVDivisions;
uniform float majorDivisionLineWidth;
uniform bool square;
uniform vec2 resolution;


const float minorDivisionLineWidth = 1.0;


void main()	{
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	vec4		inputPixelColor = bgColor;
	vec2		loc = gl_FragCoord.xy;
	vec2		divisionSize = (square) ? vec2(max(resolution.x,resolution.y)) : resolution;
	divisionSize = (divisionSize - majorDivisionLineWidth) / (1.0 + float(majorDivisions));
	vec2		modLoc = mod(loc,divisionSize);
	if ((modLoc.x < majorDivisionLineWidth)||(modLoc.y < majorDivisionLineWidth))	{
		inputPixelColor = lineColor;
	}
	if (minorHDivisions > 0)	{
		vec2	locDivisionSize = (divisionSize) / (1.0+float(minorHDivisions));
		modLoc = mod(loc,locDivisionSize);
		if (modLoc.x < minorDivisionLineWidth)	{
			inputPixelColor = lineColor;
		}
	}
	if (minorVDivisions > 0)	{
		vec2	locDivisionSize = (divisionSize) / (1.0+float(minorVDivisions));
		modLoc = mod(loc,locDivisionSize);
		if (modLoc.y < minorDivisionLineWidth)	{
			inputPixelColor = lineColor;
		}
	}

	gl_FragColor = inputPixelColor;
}
