// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(level, M*EO, -1, 1, -0.5, "No help available.")
// ISADORA_FLOAT_PARAM(radius, oHO5, 0, 1, 0.25, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0.5, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(bgColor, 8NtS, 0x00000000, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(lineColor, $98w, 0xFFF08E00, "No help available.")
// ISADORA_INT_PARAM(majorDivisions, 2IS<, 0, 16, 6, "No help available.")
// ISADORA_INT_PARAM(minorHDivisions, pD1<, 0, 8, 2, "No help available.")
// ISADORA_INT_PARAM(minorVDivisions, MFp|, 0, 8, 1, "No help available.")
// ISADORA_FLOAT_PARAM(majorDivisionLineWidth, g^PV, 1, 5, 3, "No help available.")
// ISADORA_INT_PARAM_ONOFF(square, Z<KL, 0, "No help available.")

#define center vec2(center_x,center_y)

uniform float level;
uniform float radius;
uniform float center_x;
uniform float center_y;
uniform vec4 bgColor;
uniform vec4 lineColor;
uniform int majorDivisions;
uniform int minorHDivisions;
uniform int minorVDivisions;
uniform float majorDivisionLineWidth;
uniform bool square;
uniform vec2 resolution;

const float minorDivisionLineWidth = 1.0;
const float pi = 3.14159265359;

#ifndef GL_ES
float distance (vec2 center, vec2 pt)
{
	float tmp = pow(center.x-pt.x,2.0)+pow(center.y-pt.y,2.0);
	return pow(tmp,0.5);
}
#endif

void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	vec2 uv = vec2(isf_FragNormCoord[0],isf_FragNormCoord[1]);
	vec2 texSize = resolution;
	vec2 tc = uv * texSize;
	vec2 modifiedCenter = center * resolution;
	float r = distance(modifiedCenter, tc);
	float a = atan ((tc.y-modifiedCenter.y),(tc.x-modifiedCenter.x));
	float radius_sized = radius * length(resolution);
	vec4 inputPixelColor = bgColor;
	
	tc -= modifiedCenter;

	if (r < radius_sized) 	{
		float percent = 1.0-(radius_sized - r) / radius_sized;
		if (level>=0.0)	{
			percent = percent * percent;
			tc.x = r*pow(percent,level) * cos(a);
			tc.y = r*pow(percent,level) * sin(a);
		}
		else	{
			float adjustedLevel = level/2.0;
			tc.x = r*pow(percent,adjustedLevel) * cos(a);
			tc.y = r*pow(percent,adjustedLevel) * sin(a);		
		}
	}
	tc += modifiedCenter;
	
	vec2 loc = tc;
	vec2 divisionSize = (square) ? vec2(max(resolution.x,resolution.y)) : resolution;
	divisionSize = (divisionSize - majorDivisionLineWidth) / (1.0 + float(majorDivisions));
	vec2 modLoc = mod(loc,divisionSize);
	if ((modLoc.x < majorDivisionLineWidth)||(modLoc.y < majorDivisionLineWidth))	{
		inputPixelColor = lineColor;
	}
	if (minorHDivisions > 0)	{
		vec2	locDivisionSize = (divisionSize) / (1.0+float(minorHDivisions));
		modLoc = mod(loc,locDivisionSize);
		if (modLoc.x < minorDivisionLineWidth)	{
			inputPixelColor = lineColor;
		}
	}
	if (minorVDivisions > 0)	{
		vec2	locDivisionSize = (divisionSize) / (1.0+float(minorVDivisions));
		modLoc = mod(loc,locDivisionSize);
		if (modLoc.y < minorDivisionLineWidth)	{
			inputPixelColor = lineColor;
		}
	}
	
	gl_FragColor = inputPixelColor;
}
