// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(width, ^c-[, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(angle, +nv%, -1, 1, 0.125, "No help available.")
// ISADORA_INT_PARAM(quality, 4yuj, 0, 3, 16, "No help available.")


uniform sampler2D tex0;
uniform float width;
uniform float angle;
uniform int quality;
uniform vec2 resolution;


const float pi = 3.14159265359;


void main() {
	vec2 loc = gl_TexCoord[0].xy * resolution;

	vec2 p1 = vec2(0.0);
	vec2 p2 = vec2(1.0);
	vec2 vector = vec2(cos(pi * angle),sin(pi * angle));
	
	vec4 returnMe;
	
	if (width > 0.0)	{
		p1 = loc - width * resolution * vector;
		p2 = loc + width * resolution * vector;
		
		//	now we have the two points to smear between,
		float i;
		float count = clamp(width * max(resolution.x,resolution.y) / float(quality), 5.0, 75.0);
		vec2 diff = p2 - p1;
		for (float i = 0.0; i < 75.0; ++i)	{
			if (i > float(count))
				break;
			float tmp = (i / (count - 1.0));
			returnMe = returnMe + texture2D(tex0, (p1 + diff * tmp)/resolution) / count;
		}
		
		vector = vec2(cos(pi * (0.5+ angle)),sin(pi * (0.5+ angle)));
		p1 = loc - width * resolution * vector;
		p2 = loc + width * resolution * vector;
		
		//	now we have the two points to smear between,
		diff = p2 - p1;
		for (float i = 0.0; i < 75.0; ++i)	{
			if (i > float(count))
				break;
			float tmp = (i / (count - 1.0));
			returnMe = returnMe + texture2D(tex0, (p1 + diff * tmp)/resolution) / count;
		}
		returnMe = returnMe / 2.0;
	}
	else	{
		returnMe = texture2D(tex0, gl_TexCoord[0].xy);
	}
	gl_FragColor = returnMe;
}
