// CREDIT: VIDVOX
// ISADORA_FLOAT_PARAM(centerX, x[_?, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(scrollAmount, Q3|0, 0, 2, 0, "No help available.")
// ISADORA_FLOAT_PARAM(rightScrollOffset, F$$5, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(midHeight, NgT1, 0, 1, 0.5, "No help available.")
// ISADORA_INT_PARAM_ONOFF(seamless, /jAH, 1, "No help available.")


uniform sampler2D tex0;
uniform float centerX;
uniform float scrollAmount;
uniform float rightScrollOffset;
uniform float midHeight;
uniform bool seamless;

void main()	{
	vec2		loc = gl_TexCoord[0].xy;
	if (centerX == 0.0)	{
		
	}
	else if (centerX == 1.0)	{
		
	}
	else if (loc.x < centerX)	{
		loc.x = loc.x / centerX;
		loc.y = mix(0.5 + (loc.y-0.5) / midHeight,loc.y,1.0-loc.x);
		loc.x = loc.x+scrollAmount;
		if (seamless)	{
			loc.x = ((loc.x <= 1.0)||(loc.x >= 2.0)) ? loc.x : 3.0 - loc.x;
		}
		loc.x = mod(loc.x,1.0);
	}
	else	{
		float		rightScroll = mod(rightScrollOffset+scrollAmount,2.0);
		loc.x = (1.0-loc.x) / (1.0-centerX);
		loc.y = mix(0.5 + (loc.y-0.5) / midHeight,loc.y,1.0-loc.x);
		loc.x = loc.x+rightScroll;
		if (seamless)	{
			loc.x = ((loc.x <= 1.0)||(loc.x >= 2.0)) ? loc.x : 3.0 - loc.x;
		}
		loc.x = mod(loc.x,1.0);
	}
	
	vec4		inputPixelColor = vec4(0.0);
	
	if ((loc.y >= 0.0)&&(loc.y <= 1.0))
		inputPixelColor = texture2D(tex0, loc);
	
	gl_FragColor = inputPixelColor;
}
