// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(size, ~5ox, 0, 2, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(sides, _WzC, 1, 32, 6, "No help available.")
// ISADORA_FLOAT_PARAM(rotation, le|4, 0, 1, 0.125, "No help available.")
// ISADORA_FLOAT_PARAM(angle, +nv%, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(slide1_x, U2Cs, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(slide1_y, Fuo4, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(slide2_x, FA9i, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(slide2_y, wJI-, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(shift_x, 3?IU, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(shift_y, ?6Ix, 0, 1, 0, "No help available.")

#define slide1 vec2(slide1_x,slide1_y)
#define slide2 vec2(slide2_x,slide2_y)
#define shift vec2(shift_x,shift_y)

uniform sampler2D tex0;
uniform float size;
uniform float sides;
uniform float rotation;
uniform float angle;
uniform float slide1_x;
uniform float slide1_y;
uniform float slide2_x;
uniform float slide2_y;
uniform float shift_x;
uniform float shift_y;
uniform vec2 resolution;


const float tau = 6.28318530718;


vec2 pattern() {
	float s = sin(tau * rotation);
	float c = cos(tau * rotation);
	vec2 tex = gl_TexCoord[0].xy * resolution;
	float scale = 1.0 / max(size,0.001);
	vec2 point = vec2( c * tex.x - s * tex.y, s * tex.x + c * tex.y ) * scale;
	point = (point - (shift*resolution)) / resolution;
	//	do this to repeat
	point = mod(point,1.0);
	if (point.x < 0.5)	{
		point.y = mod(point.y + slide1.y, 1.0);
	}
	else	{
		point.y = mod(point.y + slide2.y, 1.0);
	}
	if (point.y < 0.5)	{
		point.x = mod(point.x + slide1.x, 1.0);
	}
	else	{
		point.x = mod(point.x + slide2.x, 1.0);
	}
	//	do this for relections
	point = 1.0-abs(1.0-2.0*point);
	
	//	Now let's do a squish based on angle
	//	convert to polar coordinates
	vec2 center = vec2(0.5,0.5);
	float r = distance(center, point);
	float a = atan ((point.y-center.y),(point.x-center.x));
	
	// now do the kaleidoscope
	a = mod(a, tau/sides);
	a = abs(a - tau/sides/2.);
	
	s = sin(a + tau * angle);
	c = cos(a + tau * angle);
	
	float zoom = resolution.x / resolution.y;
	
	point.x = (r * c)/zoom + 0.5;
	point.y = (r * s)/zoom + 0.5;
	
	return point;
}


void main() {

	vec2 pat = pattern();

	gl_FragColor = texture2D(tex0, pat);
}
