// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(sides, _WzC, 1, 32, 6, "No help available.")
// ISADORA_FLOAT_PARAM(angle, +nv%, -1, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(slidex, 77%f, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(slidey, 3zRH, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform float sides;
uniform float angle;
uniform float slidex;
uniform float slidey;
uniform float center_x;
uniform float center_y;
uniform vec2 resolution;


const float tau = 6.28318530718;




void main() {
  // normalize to the center
	vec2 loc = resolution * vec2(gl_TexCoord[0].xy[0],gl_TexCoord[0].xy[1]);
	float r = distance(center*resolution, loc);
	float a = atan ((loc.y-center.y*resolution.y),(loc.x-center.x*resolution.x));
	
	// kaleidoscope
	a = mod(a, tau/sides);
	a = abs(a - tau/sides/2.);
	
	loc.x = r * cos(a + tau * angle);
	loc.y = r * sin(a + tau * angle);
	
	loc = (center*resolution + loc) / resolution;
	
	loc.x = mod(loc.x + slidex, 1.0);
	loc.y = mod(loc.y + slidey, 1.0);

	// sample the image
	if (loc.x < 0.0)	{
		loc.x = mod(abs(loc.x), 1.0);
	}
	if (loc.y < 0.0)	{
		loc.y = mod(abs(loc.y),1.0);
	}
	if (loc.x > 1.0)	{
		loc.x = mod(abs(1.0-loc.x),1.0);
	}
	if(loc.y > 1.0)	{
		loc.y = mod(abs(1.0-loc.y),1.0);	
	}
	gl_FragColor = texture2D(tex0, loc);;
}
