// CREDIT: by Carter Rosenberg
// ISADORA_FLOAT_PARAM(offset, 7>D/, -1000000, +1000000, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(frequency, k$UO, 1, 16, 1, "No help available.")
// ISADORA_INT_PARAM(curve, a&M0, 0, 2, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(vertical, |1G=, 0, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(startColor, x2eL, 0xFFFFBF00, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(endColor, ~nv{, 0xFF003FBF, "No help available.")


uniform float offset;
uniform float frequency;
uniform int curve;
uniform bool vertical;
uniform vec4 startColor;
uniform vec4 endColor;
uniform vec2 resolution;



const float pi = 3.14159265359;
const float e = 2.71828182846;



void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	float mixAmount = 0.0;
	float phase = offset;
	
	if (vertical)	{
		mixAmount = phase + frequency * isf_FragNormCoord[1];
	}
	else	{
		mixAmount = phase + frequency * isf_FragNormCoord[0];
	}
	
	if (curve == 0)	{
		mixAmount = mod(2.0 * mixAmount,2.0);
		mixAmount = (mixAmount < 1.0) ? mixAmount : 1.0 - (mixAmount - floor(mixAmount));
	}
	else if (curve == 1)	{
		mixAmount = sin(mixAmount * pi * 2.0 - pi / 2.0) * 0.5 + 0.5;
	}
	else if (curve == 2)	{
		mixAmount = mod(2.0 * mixAmount, 2.0);
		mixAmount = (mixAmount < 1.0) ? mixAmount : 1.0 - (mixAmount - floor(mixAmount));
		mixAmount = pow(mixAmount, 2.0);
	}
	
	gl_FragColor = mix(startColor,endColor,mixAmount);
}
