// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(luminanceThreshold, 6Csa, 0, 1, 0.2, "No help available.")
// ISADORA_FLOAT_PARAM(colorAmplification, jZP/, 0, 10, 4, "No help available.")
// ISADORA_FLOAT_PARAM(noiseLevel, FBQ2, 0, 1, 0.1, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(visionColor, 2Fl5, 0xFF19F233, "No help available.")


uniform sampler2D tex0;
uniform float luminanceThreshold;
uniform float colorAmplification;
uniform float noiseLevel;
uniform vec4 visionColor;
uniform float time;



void main ()	{
	vec2		normSrcCoord;

	normSrcCoord.x = gl_TexCoord[0].xy[0];
	normSrcCoord.y = gl_TexCoord[0].xy[1];
	
	vec4 finalColor;
	
	// Set effectCoverage to 1.0 for normal use.  

	vec2 uv;           
	uv.x = 0.4*sin(time*50.0);                                 
	uv.y = 0.4*cos(time*50.0);                                 
	vec3 n = IMG_NORM_PIXEL(noiseTex,mod(normSrcCoord.xy*3.5 + uv,1.0)).rgb;
	vec3 c = texture2D(tex0, gl_TexCoord[0].xy).rgb + n.rgb * noiseLevel;
	
	const vec4 	lumacoeff = vec4(0.2126, 0.7152, 0.0722, 0.0);
	float		lum = dot(vec4(c,1.), lumacoeff);
	if (lum < luminanceThreshold)	{
	  c *= colorAmplification; 
	}
	finalColor.rgb = (c + (n*0.2)) * visionColor.rgb;

	gl_FragColor.rgb = finalColor.rgb;
	gl_FragColor.a = 1.0;
}
