// CREDIT: VIDVOX
// ISADORA_PLUGIN_DESC("Displaces image randomly")
// ISADORA_FLOAT_PARAM(displaceX, M3B0, 0, 0.1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(displaceY, 1tk#, 0, 0.1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(detailX, 5fEy, 0, 1, 0.1, "No help available.")
// ISADORA_FLOAT_PARAM(detailY, }\Qj, 0, 1, 0.1, "No help available.")
// ISADORA_FLOAT_PARAM(updateTime, epz1, 0, 0.1, 0.01, "No help available.")


uniform sampler2D tex0;
uniform float displaceX;
uniform float displaceY;
uniform float detailX;
uniform float detailY;
uniform float updateTime;
uniform float time;


float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main()	{

	vec4 inputPixelColor;
	vec2 uv = gl_TexCoord[0].xy;
	float wobbleTime = (updateTime == 0.0) ? time : floor(time/updateTime);
	vec2 waveLoc = fract((uv)*vec2(detailX, detailY));
	float val1 = rand(vec2(waveLoc.x, wobbleTime));
	float val2 = rand(vec2(waveLoc.y, wobbleTime+1.0));
	vec2 wave = vec2(val1, val2)-0.5;
	wave *= vec2(displaceY, displaceX);

	inputPixelColor = texture2D(tex0, uv + wave.yx);

	gl_FragColor = inputPixelColor;
}
