// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/pinwheel.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(speed, UNbv, 0, 10, 2, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float speed;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: Mr Speaker
// License: MIT


vec4 transition(vec2 uv) {
  
  vec2 p = uv.xy / vec2(1.0).xy;
  
  float circPos = atan(p.y - 0.5, p.x - 0.5) + progress * speed;
  float modPos = mod(circPos, 3.1415 / 4.);
  float signed = sign(progress - modPos);
  
  return mix(getToColor(p), getFromColor(p), step(signed, 0.5));
  
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
