// CREDIT: by VIDVOX
// ISADORA_PLUGIN_DESC("Shifts pixels up and down")
// ISADORA_FLOAT_PARAM(hPhase, s7fV, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(hFrequency, I_*2, -16, 16, 1, "No help available.")
// ISADORA_FLOAT_PARAM(hRandom, *d2x, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(vPhase, Q-1q, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(vFrequency, **_O, -16, 16, 0, "No help available.")
// ISADORA_FLOAT_PARAM(vRandom, IAOM, 0, 1, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(doSin, S2fP, 1, "No help available.")
// ISADORA_INT_PARAM_ONOFF(mirror, 1ssb, 1, "No help available.")


uniform sampler2D tex0;
uniform float hPhase;
uniform float hFrequency;
uniform float hRandom;
uniform float vPhase;
uniform float vFrequency;
uniform float vRandom;
uniform bool doSin;
uniform bool mirror;
uniform float time;


float		PI_CONST = 3.14159265359;


float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}


void main()
{
	//	start with the pixel
	vec2 loc = gl_TexCoord[0].xy;
	float modVal = 1.0;
	
	if (mirror)
		modVal = 2.0;
	
	//	shift the loc.x by the frequency * loc.y + phase
	if (doSin)
		loc.x = mod(hRandom * rand(vec2(time * 0.127, loc.x)) + loc.x + sign(hFrequency) * 0.5 * (1.0+cos(2.0 * PI_CONST * (hPhase + hFrequency * loc.y))), modVal);
	else
		loc.x = mod(hRandom * rand(vec2(time * 0.129, loc.x)) + loc.x + hFrequency * loc.y + hPhase, modVal);

	//	shift the loc.y by the frequency * loc.x + phase
	if (doSin)
		loc.y = mod(vRandom * rand(vec2(time * 0.273, loc.y)) + loc.y + sign(vFrequency) * 0.5 * (1.0+cos(2.0 * PI_CONST * (vPhase + vFrequency * loc.x))), modVal);
	else
		loc.y = mod(vRandom * rand(vec2(time * 0.341, loc.y)) +loc.y + vFrequency * loc.x + vPhase, modVal);
		
	if (loc.x > 1.0)
		loc.x = 2.0 - loc.x;
		
	if (loc.y > 1.0)
		loc.y = 2.0 - loc.y;
	
	gl_FragColor = texture2D(tex0, loc);
}
