// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/pixelize.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(steps, KR^{, 0, 100, 50, "No help available.")
// ISADORA_FLOAT_PARAM(squaresMin_x, hs8J, 1, 100, 20, "No help available.")
// ISADORA_FLOAT_PARAM(squaresMin_y, zVnI, 1, 100, 20, "No help available.")

#define squaresMin vec2(squaresMin_x,squaresMin_y)

uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float steps;
uniform float squaresMin_x;
uniform float squaresMin_y;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: gre
// License: MIT
// forked from https://gist.github.com/benraziel/c528607361d90a072e98


float d = min(progress, 1.0 - progress);
float dist = steps>0 ? ceil(d * float(steps)) / float(steps) : d;
vec2 squareSize = 2.0 * dist / vec2(squaresMin);

vec4 transition(vec2 uv) {
  vec2 p = dist>0.0 ? (floor(uv / squareSize) + 0.5) * squareSize : uv;
  return mix(getFromColor(p), getToColor(p), progress);
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
