// ISADORA_FLOAT_PARAM(pointCount, >}uC, 3, 20, 5, "No help available.")
// ISADORA_FLOAT_PARAM(buldge, 5IfZ, 0, 10, 5, "No help available.")
// ISADORA_FLOAT_PARAM(pointRadiusInside, #Fl/, 0, 1, 0.1, "No help available.")
// ISADORA_FLOAT_PARAM(pointRadiusOutside, 27Ud, 0, 1, 0.1, "No help available.")
// ISADORA_FLOAT_PARAM(pointRotation, 9xn3, 0, 1, 0, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(starColor, evw~, 0xFFFFFFFF, "No help available.")


uniform float pointCount;
uniform float buldge;
uniform float pointRadiusInside;
uniform float pointRadiusOutside;
uniform float pointRotation;
uniform vec4 starColor;
uniform vec2 resolution;


float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

const float pi = 3.14159265359;

void main()	{
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	vec4 inputPixelColor = vec4(0.0);
	float angleInc = 1.0 / pointCount;
	
	vec2 loc = resolution * isf_FragNormCoord;
	//	'r' is the radius- the distance in pixels from 'loc' to the center of the rendering space
	float r = distance(resolution/2.0, loc);
	r /= max(resolution.x,resolution.y);
	//	'a' is the angle of the line segment from the center to loc is rotated
	float a = atan ((loc.y-resolution.y/2.0),(loc.x-resolution.x/2.0));
	a += pi;
	a /= 2.0*pi;
	a += pointRotation;
	//	'at' is the angle time
	float at = mod(a,angleInc) / angleInc;
	//	'rd' is the radius at this angle for the shape 
	float starness = 10.0 - buldge;
	float rd = pointRadiusOutside * pow(at,starness) + pointRadiusInside;
	inputPixelColor = (r < rd) ? starColor : vec4(0.0);
	at = 1.0 - at;
	rd = pointRadiusOutside * pow(at,starness) + pointRadiusInside;
	inputPixelColor = (r < rd) ? starColor : inputPixelColor;
	
	gl_FragColor = inputPixelColor;
}
