// ISADORA_PLUGIN_DESC("Power curves distortions with shifting")
// ISADORA_FLOAT_PARAM(power_x, _zed, 0.25, 4, 1, "No help available.")
// ISADORA_FLOAT_PARAM(power_y, 7VpJ, 0.25, 4, 1, "No help available.")
// ISADORA_FLOAT_PARAM(shift_x, 3?IU, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(shift_y, ?6Ix, 0, 1, 0, "No help available.")
// ISADORA_INT_PARAM(mode_x, w_<j, 0, 1, 1, "No help available.")
// ISADORA_INT_PARAM(mode_y, Amc], 0, 1, 1, "No help available.")


uniform sampler2D tex0;
uniform float power_x;
uniform float power_y;
uniform float shift_x;
uniform float shift_y;
uniform int mode_x;
uniform int mode_y;


const float pi = 3.14159265359;



void main()	{
	vec4		inputPixelColor;
	vec2		pos = gl_TexCoord[0].xy;
	
	if (mode_x == 0)	{
		pos.x = pow(pos.x, power_x);
	}
	else	{
		if (pos.x > 0.5)
			pos.x = 0.5 + pow(2.0*(pos.x - 0.5), power_x) / 2.0;
		else	{
			pos.x = pow(1.0 - 2.0*pos.x, power_x) / 2.0;
			pos.x = 0.5 - pos.x;
		}
	}
	pos.x = mod(pos.x + shift_x, 1.0);
	
	if (mode_y == 0)	{
		pos.y = pow(pos.y, power_y);
	}
	else	{
		if (pos.y > 0.5)
			pos.y = 0.5 + pow(2.0*(pos.y - 0.5), power_y) / 2.0;
		else	{
			pos.y = pow(1.0 - 2.0*pos.y, power_y) / 2.0;
			pos.y = 0.5 - pos.y;
		}
	}
	pos.y = mod(pos.y + shift_y, 1.0);
	
	inputPixelColor = texture2D(tex0, pos);
	
	gl_FragColor = inputPixelColor;
}
