// ISADORA_FLOAT_PARAM(pt1_x, Vsy|, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(pt1_y, &J1B, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(pt2_x, {i%S, 0, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(pt2_y, _6hR, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(pt3_x, 1eR#, 0, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(pt3_y, MPSH, 0, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(pt4_x, DKux, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(pt4_y, yJQt, 0, 1, 1, "No help available.")
// ISADORA_INT_PARAM_ONOFF(invertMask, iP{Y, 0, "No help available.")
// ISADORA_INT_PARAM(maskApplyMode, _$yA, 0, 2, 0, "No help available.")

#define pt1 vec2(pt1_x,pt1_y)
#define pt2 vec2(pt2_x,pt2_y)
#define pt3 vec2(pt3_x,pt3_y)
#define pt4 vec2(pt4_x,pt4_y)

uniform sampler2D tex0;
uniform float pt1_x;
uniform float pt1_y;
uniform float pt2_x;
uniform float pt2_y;
uniform float pt3_x;
uniform float pt3_y;
uniform float pt4_x;
uniform float pt4_y;
uniform bool invertMask;
uniform int maskApplyMode;


float sign(vec2 p1, vec2 p2, vec2 p3)
{
	return (p1.x - p3.x) * (p2.y - p3.y) - (p2.x - p3.x) * (p1.y - p3.y);
}

bool PointInTriangle(vec2 pt, vec2 v1, vec2 v2, vec2 v3)
{
	bool b1, b2, b3;

	b1 = sign(pt, v1, v2) < 0.0;
	b2 = sign(pt, v2, v3) < 0.0;
	b3 = sign(pt, v3, v1) < 0.0;

	return ((b1 == b2) && (b2 == b3));
}


void main()	{
	vec4		inputPixelColor = texture2D(tex0, gl_TexCoord[0].xy);
	vec2		loc = gl_TexCoord[0].xy;
	bool		drawPixel =  false;

	if ((PointInTriangle(loc,pt1,pt2,pt3))||(PointInTriangle(loc,pt1,pt4,pt3)))	{
		drawPixel = true;
	}
	
	if (invertMask)
		drawPixel = !drawPixel;
	
	if (maskApplyMode == 0)	{
		inputPixelColor = (drawPixel) ? inputPixelColor : vec4(0.0);
	}
	//	in this mode only the alpha is changed; the rgb remains intact and may still be visible if another filter adjusts the alpha again
	else if (maskApplyMode == 1)	{
		inputPixelColor.a = (drawPixel) ? inputPixelColor.a : 0.0;
	}
	else if (maskApplyMode == 2)	{
		inputPixelColor = (drawPixel) ? vec4(1.0) : vec4(0.0);
	}

	gl_FragColor = inputPixelColor;
}
