// CREDIT: by Carter Rosenberg
// ISADORA_FLOAT_PARAM(radius1, bP5y, -1000000, +1000000, 0.1, "No help available.")
// ISADORA_FLOAT_PARAM(radius2, <[YK, -1000000, +1000000, 0.25, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(startColor, x2eL, 0xFFFFBF00, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(endColor, ~nv{, 0xFF003FBF, "No help available.")
// ISADORA_FLOAT_PARAM(location_x, DKiS, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(location_y, iEqT, 0, 1, 0.5, "No help available.")

#define location vec2(location_x,location_y)

uniform float radius1;
uniform float radius2;
uniform vec4 startColor;
uniform vec4 endColor;
uniform float location_x;
uniform float location_y;
uniform vec2 resolution;



void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	vec2 tmpPt = location;
	float mixOffset = distance(tmpPt * resolution.x / resolution.y, isf_FragNormCoord * resolution.x / resolution.y);
	float tmpRadius = radius1 + radius2;
	if (mixOffset <= radius1)	{
		gl_FragColor = startColor;
	}
	else if (mixOffset > tmpRadius)	{
		gl_FragColor = endColor;
	}
	else if (radius1 == tmpRadius)	{
		gl_FragColor = endColor;
	}
	else	{
		gl_FragColor = mix(startColor,endColor,(mixOffset-radius1)/(tmpRadius-radius1));
	}
}
