// CREDIT: VIDVOX
// ISADORA_PLUGIN_DESC("Repllcates a radial slice of an image")
// ISADORA_FLOAT_PARAM(postRotateAngle, [b%6, 0, 360, 0, "No help available.")
// ISADORA_FLOAT_PARAM(numberOfDivisions, M7EP, 1, 360, 12, "No help available.")
// ISADORA_FLOAT_PARAM(preRotateAngle, uXMY, -180, 180, 0, "No help available.")
// ISADORA_FLOAT_PARAM(centerRadiusStart, FE~H, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(centerRadiusEnd, DJ4F, 0, 2, 1, "No help available.")


uniform sampler2D tex0;
uniform float postRotateAngle;
uniform float numberOfDivisions;
uniform float preRotateAngle;
uniform float centerRadiusStart;
uniform float centerRadiusEnd;
uniform vec2 resolution_tex0;
uniform vec2 resolution;



const float pi = 3.14159265359;




void main()	{
vec4 _inputImage_imgRect = vec4(0.0, 0.0, resolution_tex0.x, resolution_tex0.y);

	
	vec4		inputPixelColor = vec4(0.0);
	vec2		loc = _inputImage_imgRect.zw * vec2(gl_TexCoord[0].xy.x,gl_TexCoord[0].xy.y);
	//	'r' is the radius- the distance in pixels from 'loc' to the center of the rendering space
	//float		r = distance(resolution_tex0/2.0, loc);
	float		r = distance(_inputImage_imgRect.zw/2.0, loc);
	//	'a' is the angle of the line segment from the center to loc is rotated
	//float		a = atan ((loc.y-resolution_tex0.y/2.0),(loc.x-resolution_tex0.x/2.0));
	float		a = atan ((loc.y-_inputImage_imgRect.w/2.0),(loc.x-_inputImage_imgRect.z/2.0));
	float		modAngle = 2.0 * pi / numberOfDivisions;
	float		scaledCenterRadiusStart = centerRadiusStart * max(resolution.x,resolution.y);
	float		scaledCenterRadiusEnd = centerRadiusEnd * max(resolution.x,resolution.y);
	
	if (scaledCenterRadiusStart > scaledCenterRadiusEnd)	{
		scaledCenterRadiusStart = scaledCenterRadiusEnd;
		scaledCenterRadiusEnd = centerRadiusStart * max(resolution.x,resolution.y);
	}
	
	if ((centerRadiusEnd != centerRadiusStart)&&(r >= scaledCenterRadiusStart)&&(r <= scaledCenterRadiusEnd))	{
		r = (r - scaledCenterRadiusStart) / (centerRadiusEnd - centerRadiusStart);
		
		a = mod(a + pi * postRotateAngle/360.0,modAngle);
	
		//	now modify 'a', and convert the modified polar coords (radius/angle) back to cartesian coords (x/y pixels)
		loc.x = r * cos(a + 2.0 * pi * (preRotateAngle) / 360.0);
		loc.y = r * sin(a + 2.0 * pi * (preRotateAngle) / 360.0);
	
		loc = loc / _inputImage_imgRect.zw + vec2(0.5);
	
		if ((loc.x < 0.0)||(loc.y < 0.0)||(loc.x > 1.0)||(loc.y > 1.0))	{
			inputPixelColor = vec4(0.0);
		}
		else	{
			inputPixelColor = texture2D(tex0, loc);
		}
	}
	gl_FragColor = inputPixelColor;
}
