// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(width, ^c-[, -1000000, +1000000, 0.125, "No help available.")
// ISADORA_FLOAT_PARAM(offset_x, r5~+, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(offset_y, x[{~, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(alpha1, 2H*3, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(alpha2, 0bP<, 0, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(seed1, lX7=, 0, 1, 0.241, "No help available.")
// ISADORA_FLOAT_PARAM(randomThreshold, UBou, 0, 1, 0.5, "No help available.")

#define offset vec2(offset_x,offset_y)

uniform float width;
uniform float offset_x;
uniform float offset_y;
uniform float alpha1;
uniform float alpha2;
uniform sampler2D tex0;
uniform float seed1;
uniform float randomThreshold;
uniform vec2 resolution;


//	glsl doesn't include random functions
//	this is a pseudo-random function
float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}


void main() {
	//	determine if we are on an even or odd line
	//	math goes like..
	//	mod(((coord+offset) / width),2)
	
	
	vec4 out_color = IMG_THIS_NORM_PIXEL(inputImage);
	float alphaAdjust = alpha2;
	vec2 coord = gl_TexCoord[0].xy * resolution;
	vec2 shift = offset * resolution;
	float size = width * resolution.x;
	vec2 gridIndex = vec2(0.0);

	if (size == 0.0)	{
		alphaAdjust = alpha1;
	}
	else {
		gridIndex = floor((shift + coord) / size);
		float value = rand(seed1*gridIndex);
		if (value < randomThreshold)
			alphaAdjust = alpha1;
	}
	
	out_color.a *= alphaAdjust;
	
	gl_FragColor = out_color;
}
