// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/randomsquares.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(smoothness, s>84, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(size_x, Lb?H, 0, 100, 10, "No help available.")
// ISADORA_FLOAT_PARAM(size_y, aWfI, 0, 100, 10, "No help available.")

#define size vec2(size_x,size_y)

uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float smoothness;
uniform float size_x;
uniform float size_y;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: gre
// License: MIT

 
float rand (vec2 co) {
  return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

vec4 transition(vec2 p) {
  float r = rand(floor(vec2(size) * p));
  float m = smoothstep(0.0, -smoothness, r - (progress * (1.0 + smoothness)));
  return mix(getFromColor(p), getToColor(p), m);
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
