// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(randomFrequency, jfbL, 0, 1, 0, "No help available.")
// ISADORA_INT_PARAM(glitchNow, Vdoy, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(levelX, lHgZ, 0.01, 10, 2, "No help available.")
// ISADORA_FLOAT_PARAM(levelY, l\vw, 0.01, 10, 2, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0.5, "No help available.")
// ISADORA_INT_PARAM_ONOFF(randomizeWidth, WA8d, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(randomizeHeight, *A5w, 0, "No help available.")
// ISADORA_INT_PARAM_ONOFF(randomizeCenter, 8DJP, 0, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform float randomFrequency;
uniform int glitchNow;
uniform float levelX;
uniform float levelY;
uniform float center_x;
uniform float center_y;
uniform bool randomizeWidth;
uniform bool randomizeHeight;
uniform bool randomizeCenter;
uniform float time;
uniform int iFrame;

float random (vec2 st) {
    return fract(sin(dot(st.xy,vec2(12.9898,78.233)))*43758.5453123);
}

void main() {
	vec2		loc;
	vec2		modifiedCenter;
	
	loc = gl_TexCoord[0].xy;
	modifiedCenter = (randomizeCenter) ? vec2(random(vec2(time*1.24,0.234)),random(vec2(time*2.93,1.234))) : center;
	
	float		newWidth = 1.0;
	float		newHeight = 1.0;
	
	bool		doGlitch = false;
	
	if (glitchNow)	{
		doGlitch = true;
	}
	else if (randomFrequency == 1.0)	{
		doGlitch = true;
	}
	else	{
		float	val = random(vec2(time,0.2321));
		if (val <= randomFrequency)	{
			doGlitch = true;
		}
	}
	
	if (doGlitch == true)	{
		newWidth = (randomizeWidth == false) ? levelX : levelX * random(vec2(time+0.315,iFrame+32));
		newHeight = (randomizeHeight == false) ? levelY : levelY * random(vec2(time+0.942,iFrame+43));
	}
	
	loc.x = (loc.x - modifiedCenter.x)*(1.0/newWidth) + modifiedCenter.x;
	loc.y = (loc.y - modifiedCenter.y)*(1.0/newHeight) + modifiedCenter.y;
	if ((loc.x < 0.0)||(loc.y < 0.0)||(loc.x > 1.0)||(loc.y > 1.0))	{
		gl_FragColor = vec4(0.0);
	}
	else	{
		gl_FragColor = texture2D(tex0, loc);
	}
}
