// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/ripple.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(amplitude, ?6Ev, 0, 100, 100, "No help available.")
// ISADORA_FLOAT_PARAM(speed, UNbv, 0, 100, 50, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float amplitude;
uniform float speed;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: gre
// License: MIT

vec4 transition (vec2 uv) {
  vec2 dir = uv - vec2(.5);
  float dist = length(dir);
  vec2 offset = dir * (sin(progress * dist * amplitude - progress * speed) + .5) / 30.;
  return mix(
    getFromColor(uv + offset),
    getToColor(uv),
    smoothstep(0.2, 1.0, progress)
  );
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
