// CREDIT: by carter rosenberg
// ISADORA_FLOAT_PARAM(level, M*EO, 0.1, 32, 1, "No help available.")
// ISADORA_FLOAT_PARAM(offset, 7>D/, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(x_smear, j&C#, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(y_smear, 4TmK, 0.01, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0.5, "No help available.")
// ISADORA_INT_PARAM(mode, aZHp, 0, 1, 0, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform float level;
uniform float offset;
uniform float x_smear;
uniform float y_smear;
uniform float center_x;
uniform float center_y;
uniform int mode;
uniform vec2 resolution;

const float pi = 3.14159265359;

#ifndef GL_ES
float distance (vec2 inCenter, vec2 pt)
{
	float tmp = pow(inCenter.x-pt.x,2.0)+pow(inCenter.y-pt.y,2.0);
	return pow(tmp,0.5);
}
#endif

void main() {
	vec2 uv = vec2(gl_TexCoord[0].xy[0],gl_TexCoord[0].xy[1]);
	vec2 texSize = resolution;
	vec2 tc = uv * texSize;
	vec2 modifiedCenter = center * resolution;
	float r = distance(modifiedCenter, tc);
	float a = atan ((tc.y-modifiedCenter.y),(tc.x-modifiedCenter.x));
	float radius = 1.0;
	float radius_sized = radius * length(resolution);
	
	tc -= modifiedCenter;

	if (r < radius_sized) 	{
		float percent = 1.0-(radius_sized - r) / radius_sized;
		float adjustedOffset = offset * 2.0 * pi;
		if (mode == 0)	{
			tc.x = r*(1.0+sin(percent * level * 2.0 * pi + adjustedOffset))/2.0 * cos(a);
			tc.y = r*(1.0+sin(percent * level * 2.0 * pi + adjustedOffset))/2.0 * sin(a);
		}
		else if (mode == 1)	{
			tc.x = r*(1.0+sin(percent * level * 2.0 * pi * cos(adjustedOffset + percent * percent * level * 2.0 * pi)))/2.0 * cos(a);
			tc.y = r*(1.0+sin(percent * level * 2.0 * pi * cos(adjustedOffset + percent * percent * level * 2.0 * pi)))/2.0 * sin(a);
		}
		tc.x = mix(uv.x, tc.x, max(1.0-x_smear,0.001));
		tc.y = mix(uv.y, tc.y, max(1.0-y_smear,0.001));
	}
	tc += modifiedCenter;
	vec2 loc = tc / texSize;

	if ((loc.x < 0.0)||(loc.y < 0.0)||(loc.x > 1.0)||(loc.y > 1.0))	{
		gl_FragColor = vec4(0.0);
	}
	else	{
		gl_FragColor = texture2D(tex0, loc);
	}
}
