// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(magnitude, >eU=, 0, 2, 0, "No help available.")
// ISADORA_FLOAT_PARAM(intensity, d5~/, 0, 10, 1, "No help available.")


uniform sampler2D tex0;
uniform float magnitude;
uniform float intensity;
uniform vec2 resolution;
uniform float time;


const float pi = 3.14159265359;


float rand(vec2 co) {
	return fract(sin(dot(co.xy, vec2(12.9898,78.233))) * 43758.5453);
}

void main(void) {
	float offset = 0.1 * magnitude;
	vec2 uv = gl_FragCoord.xy / resolution.xy;
	float rotation = intensity * 2.0 * pi * rand(vec2(magnitude, time));
	float yOffset = offset * sin(time * 1.0 * cos(time * intensity) + rotation) * rand(vec2(magnitude, time));
	float xOffset = offset * cos(time * 1.0 * cos(time * intensity) + rotation) * rand(vec2(1.0-magnitude, time));;
	
	float zoom = 1.0 + offset;

	uv = (uv - 0.5) / zoom + 0.5;

	uv.y += yOffset;
	uv.x += xOffset;

	gl_FragColor = texture2D(tex0, uv);
}
