// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(positionVal, %&zP, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(distortion, aL%], 1, 20, 10, "No help available.")
// ISADORA_FLOAT_PARAM(magnitude, >eU=, 0, 0.2, 0.08, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0.5, "No help available.")
// ISADORA_INT_PARAM_ONOFF(background, ~3u^, 1, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform float positionVal;
uniform float distortion;
uniform float magnitude;
uniform float center_x;
uniform float center_y;
uniform bool background;
uniform vec2 resolution;



void main()
{
	//	do this junk so that the ripple starts from nothing
	vec2 uv = gl_TexCoord[0].xy;
	vec2 texCoord = uv;
	vec2 mod_center = center;
	vec4 color = vec4(0.0);
	float dist = distance(uv, mod_center);
	float adjustedTime = (positionVal * resolution.x/resolution.y - magnitude)/(1.0 - magnitude);

	if ( (dist <= (adjustedTime + magnitude)) && (dist >= (adjustedTime - magnitude)) ) 	{
		float diff = (dist - adjustedTime); 
		float powDiff = 1.0 - pow(abs(diff*distortion), 
								0.8); 
		float diffTime = diff  * powDiff; 
		vec2 diffUV = normalize(uv - mod_center); 
		texCoord = uv + (diffUV * diffTime);
		color = texture2D(tex0, texCoord);
	}
	else if (background)	{
		color = texture2D(tex0, texCoord);
	}
	gl_FragColor = color;
}
