// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(size, ~5ox, 0, 0.5, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(rotation, le|4, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(angle, +nv%, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(shift_x, 3?IU, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(shift_y, ?6Ix, 0, 1, 0.5, "No help available.")

#define shift vec2(shift_x,shift_y)

uniform sampler2D tex0;
uniform float size;
uniform float rotation;
uniform float angle;
uniform float shift_x;
uniform float shift_y;
uniform vec2 resolution;


const float tau = 6.28318530718;


vec2 pattern() {
	float s = sin(tau * rotation * 0.5);
	float c = cos(tau * rotation * 0.5);
	vec2 tex = gl_TexCoord[0].xy;
	float scale = 1.0 / max(size,0.001);
	vec2 point = vec2( c * tex.x - s * tex.y, s * tex.x + c * tex.y ) * scale;
	point = point - scale * shift;
	//	do the sine distort
	point = 0.5 + 0.5 * vec2( sin(scale * point.x), sin(scale * point.y));
	
	//	now do a rotation
	vec2 center = vec2(0.5,0.5);
	float r = distance(center, point);
	float a = atan ((point.y-center.y),(point.x-center.x));
	
	s = sin(a + tau * angle);
	c = cos(a + tau * angle);
	
	float zoom = max(abs(s),abs(c))*resolution.x / resolution.y;
	
	point.x = (r * c)/zoom + 0.5;
	point.y = (r * s)/zoom + 0.5;

	return point;
}


void main() {

	vec2 pat = pattern();

	gl_FragColor = texture2D(tex0, pat);
}
