// ISADORA_FLOAT_PARAM(xShiftAmount, $sZY, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(yShiftAmount, P2OS, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(xTileSize, 2<#%, 0, 1, 0.25, "No help available.")
// ISADORA_FLOAT_PARAM(yTileSize, &F26, 0, 1, 0.25, "No help available.")


uniform sampler2D tex0;
uniform float xShiftAmount;
uniform float yShiftAmount;
uniform float xTileSize;
uniform float yTileSize;
uniform vec2 resolution;

void main()	{
	vec2		loc = gl_TexCoord[0].xy;
	vec2		coords = vec2(0.0);
	coords.x = (xTileSize == 0.0) ? gl_FragCoord.x : floor(loc.x / yTileSize);
	coords.y = (yTileSize == 0.0) ? gl_FragCoord.y : floor(loc.y / xTileSize);
	
	vec2		maxCoords = vec2(0.0);
	maxCoords.x = (xTileSize == 0.0) ? resolution.x : (1.0 / yTileSize);
	maxCoords.y = (yTileSize == 0.0) ? resolution.y : (1.0 / xTileSize);
	vec2		shiftAmount = vec2(xShiftAmount, yShiftAmount);
	
	shiftAmount.x = shiftAmount.x + shiftAmount.x * coords.y / maxCoords.y;
	
	if (shiftAmount.x < 0.0)
		shiftAmount.x = 0.0;
	else if (shiftAmount.x > 1.0)
		shiftAmount.x = 1.0;
	
	loc.x = mod(loc.x + shiftAmount.x, 1.0);
	
	shiftAmount.y = shiftAmount.y + shiftAmount.y * coords.x / maxCoords.x;
	
	if (shiftAmount.y < 0.0)
		shiftAmount.y = 0.0;
	else if (shiftAmount.y > 1.0)
		shiftAmount.y = 1.0;
	
	loc.y = mod(loc.y + shiftAmount.y, 1.0);
	
	gl_FragColor = texture2D(tex0, loc);
}
