// CREDIT: VIDVOX
// ISADORA_PLUGIN_DESC("Maps video onto a sphere")
// ISADORA_FLOAT_PARAM(imageScale, o2cf, 0.125, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(radiusScale, |7XR, 0, 1.999, 1, "No help available.")
// ISADORA_FLOAT_PARAM(pointInput_x, g~_q, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(pointInput_y, 8WlQ, 0, 1, 0, "No help available.")

#define pointInput vec2(pointInput_x,pointInput_y)

uniform sampler2D tex0;
uniform float imageScale;
uniform float radiusScale;
uniform float pointInput_x;
uniform float pointInput_y;
uniform vec2 resolution;



const float pi = 3.14159265359;


void main()	{
	vec4		inputPixelColor = vec4(0.0);
	vec2		rotate = pointInput;
 	vec2 		p = 2.0 * gl_TexCoord[0].xy - 1.0;
 	float		aspect = resolution.x / resolution.y;
 	p.x = p.x * aspect;
 	
 	float		r = sqrt(dot(p,p)) * (2.0-radiusScale);
 	if (r < 1.0)	{
		vec2 uv;
    	float f = imageScale * (1.0-sqrt(1.0-r))/(r);
    	uv.x = mod(p.x*f + rotate.x,1.0);
    	uv.y = mod(p.y*f + rotate.y,1.0);
    	inputPixelColor = texture2D(tex0, uv);
	}


	//	both of these are also the same
	//inputPixelColor = texture2D(tex0, loc);
	
	gl_FragColor = inputPixelColor;
}
