// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(rotation, le|4, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(count, ayS=, 0.1, 50, 2, "No help available.")
// ISADORA_FLOAT_PARAM(width, ^c-[, 0, 0.25, 0.125, "No help available.")
// ISADORA_FLOAT_PARAM(softness, *0+x, 0, 1, 0.25, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color1, Yc>j, 0x00000000, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color2, CrWY, 0xFFFFFFFF, "No help available.")


uniform float rotation;
uniform float count;
uniform float width;
uniform float softness;
uniform vec4 color1;
uniform vec4 color2;
uniform vec2 resolution;


const float pi = 3.14159265359;


void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	//	determine if we are on an even or odd line
	//	math goes like..
	//	r = a + b*theta
	//	Changing the parameter 'a' will turn the spiral, while 'b' controls the distance between successive turnings.
	
	
	vec4 out_color = color1;
	
	//	convert to polar coordinates
	vec2 loc = vec2(isf_FragNormCoord[0],isf_FragNormCoord[1]);
	loc.y = (loc.y - 0.5) * resolution.y / resolution.x + 0.5;
	float r = 2.0 * count * distance(vec2(0.5,0.5), loc) + width;
	float theta = atan ((loc.y-0.5),(loc.x-0.5));

	loc.y = r * sin(theta + 2.0 * pi * rotation) + 0.5;

	if (loc.y < 0.5)	{
		theta = theta + 2.0 * pi;
		theta = mod(theta + rotation * 2.0 * pi, 2.0 * pi);
		theta = (theta + 2.0 * pi * floor(r - width));
	}
	else	{
		theta = mod(theta + rotation * 2.0 * pi, 2.0 * pi);
		theta = (theta + 2.0 * pi * floor(r + width));
	}
	
	if (width == 0.0)	{
		out_color = color1;
	}
	else 	{
		float dist = abs(r - theta/(2.0*pi));
		if (dist < width)	{
			if (dist > width * (1.0-softness))	{
				out_color = mix(color2, color1, (dist - width * (1.0-softness))/(width - width * (1.0-softness)));
			}
			else	{
				out_color = color2;
			}
		}
	}
	
	gl_FragColor = out_color;
}
