// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/squareswire.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(smoothness, s>84, 0, 10, 1.6, "No help available.")
// ISADORA_FLOAT_PARAM(direction_x, /ySg, -1, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(direction_y, 1>51, -1, 1, -0.5, "No help available.")
// ISADORA_FLOAT_PARAM(squares_x, YE*h, 0, 100, 10, "No help available.")
// ISADORA_FLOAT_PARAM(squares_y, Vubd, 0, 100, 10, "No help available.")

#define direction vec2(direction_x,direction_y)
#define squares vec2(squares_x,squares_y)

uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float smoothness;
uniform float direction_x;
uniform float direction_y;
uniform float squares_x;
uniform float squares_y;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: gre
// License: MIT
 

const vec2 center = vec2(0.5, 0.5);
vec4 transition (vec2 p) {
  vec2 v = normalize(direction);
  v /= abs(v.x)+abs(v.y);
  float d = v.x * center.x + v.y * center.y;
  float offset = smoothness;
  float pr = smoothstep(-offset, 0.0, v.x * p.x + v.y * p.y - (d-0.5+progress*(1.+offset)));
  vec2 squarep = fract(p*vec2(squares));
  vec2 squaremin = vec2(pr/2.0);
  vec2 squaremax = vec2(1.0 - pr/2.0);
  float a = (1.0 - step(progress, 0.0)) * step(squaremin.x, squarep.x) * step(squaremin.y, squarep.y) * step(squarep.x, squaremax.x) * step(squarep.y, squaremax.y);
  return mix(getFromColor(p), getToColor(p), a);
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
