// CREDIT: VIDVOX
// ISADORA_PLUGIN_DESC("Warps the video into a trapezoid shape")
// ISADORA_FLOAT_PARAM(topWidth, \oe>, 0, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(bottomWidth, \ge9, 0, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(heightScale, \RSD, 0, 1, 1, "No help available.")


uniform sampler2D tex0;
uniform float topWidth;
uniform float bottomWidth;
uniform float heightScale;

void main()	{
	vec4		inputPixelColor = vec4(0.0);
	vec2		loc = gl_TexCoord[0].xy;
	if (heightScale > 0.0)	{
		float	heightDivisor = 1.0 / heightScale;
		loc.y = loc.y * heightDivisor + (1.0 - heightDivisor) / 2.0;
		float		currentLineWidth = mix(bottomWidth,topWidth,loc.y);
		if (currentLineWidth > 0.0)	{
			float		lwDivisor = 1.0 / currentLineWidth;
			loc.x = loc.x * lwDivisor + (1.0 - lwDivisor) / 2.0;
	
			if ((loc.x >= 0.0)&&(loc.x <= 1.0)&&(loc.y >= 0.0)&&(loc.y <= 1.0))	{
				inputPixelColor = texture2D(tex0, loc);	
			}
		}
	}
	gl_FragColor = inputPixelColor;
}
