// CREDIT: VIDVOX
// ISADORA_PLUGIN_DESC("Warps an image to fit in a triangle by fitting the height of the image to the height of a triangle")
// ISADORA_FLOAT_PARAM(peakPoint_x, t2Cn, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(peakPoint_y, leaF, 0, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(distortX, $+~i, 0, 1, 0, "No help available.")

#define peakPoint vec2(peakPoint_x,peakPoint_y)

uniform sampler2D tex0;
uniform float peakPoint_x;
uniform float peakPoint_y;
uniform float distortX;

void main()	{
	vec4		inputPixelColor = vec4(0.0);
	vec2		pt = gl_TexCoord[0].xy;
	float		val = 0.0;
	
	if (pt.x < peakPoint.x)	{
		pt.x = pt.x * 0.5 / peakPoint.x;
		val = 2.0 * pt.x * peakPoint.y;
	}
	else	{
		pt.x = 0.5 + 0.5 * (pt.x - peakPoint.x) / (1.0 - peakPoint.x);
		val = (2.0 - 2.0 * pt.x) * peakPoint.y;
	}
	if (pt.y <= val)	{
		pt.x = mix(gl_TexCoord[0].xy.x,pt.x,distortX);
		pt.y /= val;
		inputPixelColor = texture2D(tex0, pt);
	}
	
	gl_FragColor = inputPixelColor;
}
