// CREDIT: by Carter Rosenberg
// ISADORA_FLOAT_PARAM(pt1_x, Vsy|, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(pt1_y, &J1B, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(pt2_x, {i%S, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(pt2_y, _6hR, 0, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(pt3_x, 1eR#, 0, 1, 1, "No help available.")
// ISADORA_FLOAT_PARAM(pt3_y, MPSH, 0, 1, 0, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(fillColor, d+IY, 0xFFFFFFFF, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(bgColor, 8NtS, 0x00000000, "No help available.")

#define pt1 vec2(pt1_x,pt1_y)
#define pt2 vec2(pt2_x,pt2_y)
#define pt3 vec2(pt3_x,pt3_y)

uniform float pt1_x;
uniform float pt1_y;
uniform float pt2_x;
uniform float pt2_y;
uniform float pt3_x;
uniform float pt3_y;
uniform vec4 fillColor;
uniform vec4 bgColor;
uniform vec2 resolution;


//	functions via http://stackoverflow.com/questions/2049582/how-to-determine-a-point-in-a-triangle

float sign(vec2 p1, vec2 p2, vec2 p3)
{
	return (p1.x - p3.x) * (p2.y - p3.y) - (p2.x - p3.x) * (p1.y - p3.y);
}

bool PointInTriangle(vec2 pt, vec2 v1, vec2 v2, vec2 v3)
{
	bool b1, b2, b3;

	b1 = sign(pt, v1, v2) < 0.0;
	b2 = sign(pt, v2, v3) < 0.0;
	b3 = sign(pt, v3, v1) < 0.0;

	return ((b1 == b2) && (b2 == b3));
}


void main() {
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	vec2 loc = isf_FragNormCoord;
	vec4 outColor = vec4(0.0);
	vec2 point1 = pt1;
	vec2 point2 = pt2;
	vec2 point3 = pt3;
	
	//	determine if we are inside or outside of the triangle
	
	gl_FragColor = mix(bgColor, fillColor, float(PointInTriangle(loc, point1,point2,point3)));;
}
