// CREDIT: by VIDVOX
// ISADORA_FLOAT_PARAM(radius, oHO5, 0, 1, 5, "No help available.")
// ISADORA_FLOAT_PARAM(amount, lhG|, -10, 10, 0, "No help available.")
// ISADORA_FLOAT_PARAM(center_x, tvT}, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(center_y, }%&g, 0, 1, 0.5, "No help available.")

#define center vec2(center_x,center_y)

uniform sampler2D tex0;
uniform float radius;
uniform float amount;
uniform float center_x;
uniform float center_y;
uniform vec2 resolution;


const float pi = 3.14159265359;


void main (void)
{
	vec2 uv = vec2(gl_TexCoord[0].xy[0],gl_TexCoord[0].xy[1]);
	vec2 texSize = resolution;
	vec2 tc = uv * texSize;
	float radius_sized = radius * max(resolution.x,resolution.y);
	tc -= (center * resolution);
	float dist = length(tc);
	if (dist < radius_sized) 	{
		float percent = (radius_sized - dist) / radius_sized;
		float theta = percent * percent * amount * 2.0 * pi;
		float s = sin(theta);
		float c = cos(theta);
		tc = vec2(dot(tc, vec2(c, -s)), dot(tc, vec2(s, c)));
	}
	tc += (center * resolution);
	vec2 loc = tc / texSize;
	vec4 color = texture2D(tex0, loc);

	if ((loc.x < 0.0)||(loc.y < 0.0)||(loc.x > 1.0)||(loc.y > 1.0))	{
		gl_FragColor = vec4(0.0);
	}
	else	{
		gl_FragColor = color;
	}
}
