// CREDIT: VIDVOX
// ISADORA_FLOAT_PARAM(audioLevel, u?PF, 0, 1, 1, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color1, Yc>j, 0xFF00FF00, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color2, CrWY, 0xFFFFFF00, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(color3, yK2k, 0xFFFF0000, "No help available.")


uniform float audioLevel;
uniform vec4 color1;
uniform vec4 color2;
uniform vec4 color3;
uniform vec2 resolution;


const float divisionCount = 5.0;

float round(float val)	{
	if (fract(val) <= 0.5)
		return floor(val);
	else
		return ceil(val);	
}

void main()	{
vec2 isf_FragNormCoord = gl_FragCoord.xy / resolution.xy;

	vec4		inputPixelColor = vec4(0.0);
	vec2		loc = isf_FragNormCoord;
	
	float		div = floor(divisionCount * audioLevel);
	float		thisDiv = floor(loc.x * divisionCount);
	float		nearestDiv = round(loc.x * divisionCount);
	
	if (loc.x < div / divisionCount)	{
		if (thisDiv <= divisionCount * 0.5)
			inputPixelColor = color1;
		else if (thisDiv <= divisionCount - 2.0)
			inputPixelColor = color2;
		else
			inputPixelColor = color3;
	}
	
	gl_FragColor = inputPixelColor;
}
