// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/WaterDrop.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(speed, UNbv, 0, 100, 30, "No help available.")
// ISADORA_FLOAT_PARAM(amplitude, ?6Ev, 0, 100, 30, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float speed;
uniform float amplitude;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// author: Paweł Płóciennik
// license: MIT

vec4 transition(vec2 p) {
  vec2 dir = p - vec2(.5);
  float dist = length(dir);

  if (dist > progress) {
    return mix(getFromColor( p), getToColor( p), progress);
  } else {
    vec2 offset = dir * sin(dist * amplitude - progress * speed);
    return mix(getFromColor( p + offset), getToColor( p), progress);
  }
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
