// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/windowslice.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(count, ayS=, 0, 100, 10, "No help available.")
// ISADORA_FLOAT_PARAM(smoothness, s>84, 0, 1, 0.5, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float count;
uniform float smoothness;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// Author: gre
// License: MIT


vec4 transition (vec2 p) {
  float pr = smoothstep(-smoothness, 0.0, p.x - progress * (1.0 + smoothness));
  float s = step(pr, fract(count * p.x));
  return mix(getFromColor(p), getToColor(p), s);
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
