// CREDIT: by v002
// ISADORA_FLOAT_PARAM(invert, }eJ_, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(separation, +9J0, 0, 0.5, 0.25, "No help available.")
// ISADORA_FLOAT_PARAM(greyscale, MNwR, 0, 1, 0.75, "No help available.")
// ISADORA_FLOAT_PARAM(thickness, t3\T, 0.5, 1, 0.75, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(front, Ne~D, 0xFF7F003F, "No help available.")
// ISADORA_VEC4_COLOR_PARAM(back, L#?j, 0xFF33BF7F, "No help available.")


uniform sampler2D tex0;
uniform float invert;
uniform float separation;
uniform float greyscale;
uniform float thickness;
uniform vec4 front;
uniform vec4 back;


//Original Source
//http://learningwebgl.com/blog/?p=2858

//	Based on https://github.com/v002/v002-Half-Tones/




const vec4 lumacoeff = vec4(0.2126, 0.7152, 0.0722, 0.0);


void main()
{
    vec4 color = texture2D(tex0, gl_TexCoord[0].xy);
    float lum = dot(color, lumacoeff);
    vec2 coord = gl_FragCoord.xy;
    
    vec4 colora = mix(front, back, invert);
    vec4 colorb = mix(back, front, invert);
    
    colora.a *= color.a;
    colorb.a *= color.a;
    
    vec4 cout = mix(color,colora, greyscale);

    gl_FragColor = colorb;
    
    if (lum > 1.00)
    {
        if (mod(coord.x + coord.y, thickness) >= separation)
            gl_FragColor = cout;
    }
    
    if (lum > 0.75)
    {
        if (mod(coord.x - coord.y, thickness) >= separation )
            gl_FragColor = cout;
    }
    
    if (lum > 0.50)
    {
        if (mod(coord.x + coord.y - (thickness * 0.5), thickness) >= separation)
            gl_FragColor = cout;
    }
    
    if (lum > 0.3)
    {
        if (mod(coord.x - coord.y - (thickness * 0.5), thickness) >= separation)
            gl_FragColor = cout;
    }
}
