// CREDIT: by v002
// ISADORA_FLOAT_PARAM(vignette, %X2p, 0, 1, 0.5, "No help available.")
// ISADORA_FLOAT_PARAM(vignetteEdge, j|cl, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(vignetteMix, ZuQz, 0, 1, 0, "No help available.")


uniform sampler2D tex0;
uniform float vignette;
uniform float vignetteEdge;
uniform float vignetteMix;


//	Based on v002 vignette – https://github.com/v002/v002-Film-Effects/



// create a black and white oval about the center of our image for our vignette
vec4 vignetteFucntion(vec2 normalizedTexcoord, float vignetteedge, float vignetteMix)
{
	normalizedTexcoord = 2.0 * normalizedTexcoord - 1.0; // - 1.0 to 1.0
	float r = length(normalizedTexcoord);
	vec4 vignette = (vec4(smoothstep(0.0, 1.0, pow(clamp(r - vignetteMix, 0.0, 1.0), 1.0 + vignetteedge * 10.0))));
	return clamp(1.0 - vignette, 0.0, 1.0);
}



void main (void) 
{ 		
	vec2 normcoord = vec2(gl_TexCoord[0].xy[0],gl_TexCoord[0].xy[1]);


	// make a vignette around our borders.
	vec4 vignetteResult = vignetteFucntion(normcoord, vignetteEdge, vignetteMix);

	// sharpen via unsharp mask (subtract image from blured image)
	vec4 input0 = texture2D(tex0, gl_TexCoord[0].xy);

	gl_FragColor = mix(input0,vignetteResult * input0, vignette);		
} 
