// CREDIT: by vade
// ISADORA_PLUGIN_DESC("CRT Displacement, emulating the look of curved CRT Displays")
// ISADORA_FLOAT_PARAM(Amount, M=R5, 0, 1, 0.5, "No help available.")


uniform sampler2D tex0;
uniform float Amount;
uniform vec2 resolution;

void main (void) 
{ 
	vec2 t1, t2;
	vec2 ctr = resolution / 2.0;
	
	t1 = gl_FragCoord.xy;
	
	float a = -0.0;
	float b = -.1 * Amount;
	float c = -.0;
	float d = 1.0  - 1.1 * ( a + b + c );
	float r1, r2;
	float unit = length(ctr) / 2.0;
	
	r1 = distance( t1, ctr )/unit;
	r2 =  r1 *( r1*( r1 * (a*r1 + b) + c) + d );
	float sc = step( 0.0 , r1) * ( r1/(r2 + .000001)) + (1.0 - step( 0.0 , r1));

	t2  = ctr + ( t1 - ctr) * sc;
	
	gl_FragColor = texture2D(tex0, (t2)/resolution);
			
	if ((t2.x < 0.0)
		||(t2.y < 0.0)
		||(t2.x > resolution.x)
		||(t2.y > resolution.y)) 
	{
		gl_FragColor = vec4(0.0);
	}
}
