// CREDIT: by vade
// ISADORA_PLUGIN_DESC("CRT Mask, emulating the look of curved CRT Displays")
// ISADORA_FLOAT_PARAM(Amount, M=R5, 0, 1, 0.5, "No help available.")
// ISADORA_INT_PARAM(style, J#P<, 0, 3, 0, "No help available.")


uniform sampler2D tex0;
uniform float Amount;
uniform int style;

void main (void) 
{ 
	vec2 crtcoord = mod(gl_FragCoord.xy, 12.0);
	vec4 crt;
	
	if (style == 0)
		crt = IMG_PIXEL(CRTMask0, crtcoord);
	else if (style == 1)
		crt = IMG_PIXEL(CRTMask1, crtcoord);
	else if (style == 2)
		crt = IMG_PIXEL(CRTMask2, crtcoord);
	else if (style == 3)
		crt = IMG_PIXEL(CRTMask3, crtcoord);

	vec4 image = texture2D(tex0, gl_TexCoord[0].xy);
	vec4 result = mix(image, image * crt, Amount);
	
	result.a = image.a;
	
	gl_FragColor = result;
}
